import{S as Bm,i as ym,s as km,e as a,k as m,w as $,t as n,M as Tm,c as s,d as o,m as f,a as i,x as w,h as r,b as c,N as Pm,G as e,g as _,y as B,q as y,o as k,B as T,v as xm,L as Ee}from"../../chunks/vendor-hf-doc-builder.js";import{T as hn}from"../../chunks/Tip-hf-doc-builder.js";import{D as z}from"../../chunks/Docstring-hf-doc-builder.js";import{C as je}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as X}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as Ce}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";function Cm(x){let d,b,u,h,v;return h=new je({props:{code:`from transformers import (
    Blip2VisionConfig,
    Blip2QFormerConfig,
    OPTConfig,
    Blip2Config,
    Blip2ForConditionalGeneration,
)

# Initializing a Blip2Config with Salesforce/blip2-opt-2.7b style configuration
configuration = Blip2Config()

# Initializing a Blip2ForConditionalGeneration (with random weights) from the Salesforce/blip2-opt-2.7b style configuration
model = Blip2ForConditionalGeneration(configuration)

# Accessing the model configuration
configuration = model.config

# We can also initialize a Blip2Config from a Blip2VisionConfig, Blip2QFormerConfig and any PretrainedConfig

# Initializing BLIP-2 vision, BLIP-2 Q-Former and language model configurations
vision_config = Blip2VisionConfig()
qformer_config = Blip2QFormerConfig()
text_config = OPTConfig()

config = Blip2Config.from_text_vision_configs(vision_config, qformer_config, text_config)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> (
<span class="hljs-meta">... </span>    Blip2VisionConfig,
<span class="hljs-meta">... </span>    Blip2QFormerConfig,
<span class="hljs-meta">... </span>    OPTConfig,
<span class="hljs-meta">... </span>    Blip2Config,
<span class="hljs-meta">... </span>    Blip2ForConditionalGeneration,
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a Blip2Config with Salesforce/blip2-opt-2.7b style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = Blip2Config()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a Blip2ForConditionalGeneration (with random weights) from the Salesforce/blip2-opt-2.7b style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = Blip2ForConditionalGeneration(configuration)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Accessing the model configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = model.config

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># We can also initialize a Blip2Config from a Blip2VisionConfig, Blip2QFormerConfig and any PretrainedConfig</span>

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing BLIP-2 vision, BLIP-2 Q-Former and language model configurations</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>vision_config = Blip2VisionConfig()
<span class="hljs-meta">&gt;&gt;&gt; </span>qformer_config = Blip2QFormerConfig()
<span class="hljs-meta">&gt;&gt;&gt; </span>text_config = OPTConfig()

<span class="hljs-meta">&gt;&gt;&gt; </span>config = Blip2Config.from_text_vision_configs(vision_config, qformer_config, text_config)`}}),{c(){d=a("p"),b=n("Example:"),u=m(),$(h.$$.fragment)},l(l){d=s(l,"P",{});var p=i(d);b=r(p,"Example:"),p.forEach(o),u=f(l),w(h.$$.fragment,l)},m(l,p){_(l,d,p),e(d,b),_(l,u,p),B(h,l,p),v=!0},p:Ee,i(l){v||(y(h.$$.fragment,l),v=!0)},o(l){k(h.$$.fragment,l),v=!1},d(l){l&&o(d),l&&o(u),T(h,l)}}}function Em(x){let d,b,u,h,v;return h=new je({props:{code:`from transformers import Blip2VisionConfig, Blip2VisionModel

# Initializing a Blip2VisionConfig with Salesforce/blip2-opt-2.7b style configuration
configuration = Blip2VisionConfig()

# Initializing a Blip2VisionModel (with random weights) from the Salesforce/blip2-opt-2.7b style configuration
model = Blip2VisionModel(configuration)

# Accessing the model configuration
configuration = model.config`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> Blip2VisionConfig, Blip2VisionModel

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a Blip2VisionConfig with Salesforce/blip2-opt-2.7b style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = Blip2VisionConfig()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a Blip2VisionModel (with random weights) from the Salesforce/blip2-opt-2.7b style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = Blip2VisionModel(configuration)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Accessing the model configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = model.config`}}),{c(){d=a("p"),b=n("Example:"),u=m(),$(h.$$.fragment)},l(l){d=s(l,"P",{});var p=i(d);b=r(p,"Example:"),p.forEach(o),u=f(l),w(h.$$.fragment,l)},m(l,p){_(l,d,p),e(d,b),_(l,u,p),B(h,l,p),v=!0},p:Ee,i(l){v||(y(h.$$.fragment,l),v=!0)},o(l){k(h.$$.fragment,l),v=!1},d(l){l&&o(d),l&&o(u),T(h,l)}}}function jm(x){let d,b,u,h,v;return h=new je({props:{code:`from transformers import Blip2QFormerConfig, Blip2QFormerModel

# Initializing a BLIP-2 Salesforce/blip2-opt-2.7b style configuration
configuration = Blip2QFormerConfig()

# Initializing a model (with random weights) from the Salesforce/blip2-opt-2.7b style configuration
model = Blip2QFormerModel(configuration)
# Accessing the model configuration
configuration = model.config`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> Blip2QFormerConfig, Blip2QFormerModel

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a BLIP-2 Salesforce/blip2-opt-2.7b style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = Blip2QFormerConfig()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a model (with random weights) from the Salesforce/blip2-opt-2.7b style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = Blip2QFormerModel(configuration)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Accessing the model configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = model.config`}}),{c(){d=a("p"),b=n("Examples:"),u=m(),$(h.$$.fragment)},l(l){d=s(l,"P",{});var p=i(d);b=r(p,"Examples:"),p.forEach(o),u=f(l),w(h.$$.fragment,l)},m(l,p){_(l,d,p),e(d,b),_(l,u,p),B(h,l,p),v=!0},p:Ee,i(l){v||(y(h.$$.fragment,l),v=!0)},o(l){k(h.$$.fragment,l),v=!1},d(l){l&&o(d),l&&o(u),T(h,l)}}}function qm(x){let d,b,u,h,v;return{c(){d=a("p"),b=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),u=a("code"),h=n("Module"),v=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=s(l,"P",{});var p=i(d);b=r(p,"Although the recipe for forward pass needs to be defined within this function, one should call the "),u=s(p,"CODE",{});var E=i(u);h=r(E,"Module"),E.forEach(o),v=r(p,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),p.forEach(o)},m(l,p){_(l,d,p),e(d,b),e(d,u),e(u,h),e(d,v)},d(l){l&&o(d)}}}function Mm(x){let d,b,u,h,v;return{c(){d=a("p"),b=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),u=a("code"),h=n("Module"),v=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=s(l,"P",{});var p=i(d);b=r(p,"Although the recipe for forward pass needs to be defined within this function, one should call the "),u=s(p,"CODE",{});var E=i(u);h=r(E,"Module"),E.forEach(o),v=r(p,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),p.forEach(o)},m(l,p){_(l,d,p),e(d,b),e(d,u),e(u,h),e(d,v)},d(l){l&&o(d)}}}function zm(x){let d,b,u,h,v;return h=new je({props:{code:`from PIL import Image
import requests
from transformers import Blip2Processor, Blip2Model
import torch

device = "cuda" if torch.cuda.is_available() else "cpu"

processor = Blip2Processor.from_pretrained("Salesforce/blip2-opt-2.7b")
model = Blip2Model.from_pretrained("Salesforce/blip2-opt-2.7b", torch_dtype=torch.float16)
model.to(device)
url = "http://images.cocodataset.org/val2017/000000039769.jpg"
image = Image.open(requests.get(url, stream=True).raw)

prompt = "Question: how many cats are there? Answer:"
inputs = processor(images=image, text=prompt, return_tensors="pt").to(device, torch.float16)

outputs = model(**inputs)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> Blip2Processor, Blip2Model
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span>device = <span class="hljs-string">&quot;cuda&quot;</span> <span class="hljs-keyword">if</span> torch.cuda.is_available() <span class="hljs-keyword">else</span> <span class="hljs-string">&quot;cpu&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>processor = Blip2Processor.from_pretrained(<span class="hljs-string">&quot;Salesforce/blip2-opt-2.7b&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = Blip2Model.from_pretrained(<span class="hljs-string">&quot;Salesforce/blip2-opt-2.7b&quot;</span>, torch_dtype=torch.float16)
<span class="hljs-meta">&gt;&gt;&gt; </span>model.to(device)
<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;http://images.cocodataset.org/val2017/000000039769.jpg&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = Image.<span class="hljs-built_in">open</span>(requests.get(url, stream=<span class="hljs-literal">True</span>).raw)

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt = <span class="hljs-string">&quot;Question: how many cats are there? Answer:&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = processor(images=image, text=prompt, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>).to(device, torch.float16)

<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)`}}),{c(){d=a("p"),b=n("Examples:"),u=m(),$(h.$$.fragment)},l(l){d=s(l,"P",{});var p=i(d);b=r(p,"Examples:"),p.forEach(o),u=f(l),w(h.$$.fragment,l)},m(l,p){_(l,d,p),e(d,b),_(l,u,p),B(h,l,p),v=!0},p:Ee,i(l){v||(y(h.$$.fragment,l),v=!0)},o(l){k(h.$$.fragment,l),v=!1},d(l){l&&o(d),l&&o(u),T(h,l)}}}function Im(x){let d,b,u,h,v;return{c(){d=a("p"),b=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),u=a("code"),h=n("Module"),v=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=s(l,"P",{});var p=i(d);b=r(p,"Although the recipe for forward pass needs to be defined within this function, one should call the "),u=s(p,"CODE",{});var E=i(u);h=r(E,"Module"),E.forEach(o),v=r(p,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),p.forEach(o)},m(l,p){_(l,d,p),e(d,b),e(d,u),e(u,h),e(d,v)},d(l){l&&o(d)}}}function Fm(x){let d,b,u,h,v;return h=new je({props:{code:`import torch
from transformers import AutoTokenizer, Blip2Model

device = "cuda" if torch.cuda.is_available() else "cpu"

model = Blip2Model.from_pretrained("Salesforce/blip2-opt-2.7b", torch_dtype=torch.float16)

model.to(device)
tokenizer = AutoTokenizer.from_pretrained("Salesforce/blip2-opt-2.7b")
inputs = tokenizer(["a photo of a cat", "a photo of a dog"], padding=True, return_tensors="pt").to(device)
text_features = model.get_text_features(**inputs)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, Blip2Model

<span class="hljs-meta">&gt;&gt;&gt; </span>device = <span class="hljs-string">&quot;cuda&quot;</span> <span class="hljs-keyword">if</span> torch.cuda.is_available() <span class="hljs-keyword">else</span> <span class="hljs-string">&quot;cpu&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>model = Blip2Model.from_pretrained(<span class="hljs-string">&quot;Salesforce/blip2-opt-2.7b&quot;</span>, torch_dtype=torch.float16)

<span class="hljs-meta">&gt;&gt;&gt; </span>model.to(device)
<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;Salesforce/blip2-opt-2.7b&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer([<span class="hljs-string">&quot;a photo of a cat&quot;</span>, <span class="hljs-string">&quot;a photo of a dog&quot;</span>], padding=<span class="hljs-literal">True</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>).to(device)
<span class="hljs-meta">&gt;&gt;&gt; </span>text_features = model.get_text_features(**inputs)`}}),{c(){d=a("p"),b=n("Examples:"),u=m(),$(h.$$.fragment)},l(l){d=s(l,"P",{});var p=i(d);b=r(p,"Examples:"),p.forEach(o),u=f(l),w(h.$$.fragment,l)},m(l,p){_(l,d,p),e(d,b),_(l,u,p),B(h,l,p),v=!0},p:Ee,i(l){v||(y(h.$$.fragment,l),v=!0)},o(l){k(h.$$.fragment,l),v=!1},d(l){l&&o(d),l&&o(u),T(h,l)}}}function Lm(x){let d,b,u,h,v;return{c(){d=a("p"),b=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),u=a("code"),h=n("Module"),v=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=s(l,"P",{});var p=i(d);b=r(p,"Although the recipe for forward pass needs to be defined within this function, one should call the "),u=s(p,"CODE",{});var E=i(u);h=r(E,"Module"),E.forEach(o),v=r(p,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),p.forEach(o)},m(l,p){_(l,d,p),e(d,b),e(d,u),e(u,h),e(d,v)},d(l){l&&o(d)}}}function Am(x){let d,b,u,h,v;return h=new je({props:{code:`import torch
from PIL import Image
import requests
from transformers import AutoProcessor, Blip2Model

device = "cuda" if torch.cuda.is_available() else "cpu"

model = Blip2Model.from_pretrained("Salesforce/blip2-opt-2.7b", torch_dtype=torch.float16)

model.to(device)
processor = AutoProcessor.from_pretrained("Salesforce/blip2-opt-2.7b")
url = "http://images.cocodataset.org/val2017/000000039769.jpg"
image = Image.open(requests.get(url, stream=True).raw)
inputs = processor(images=image, return_tensors="pt").to(device, torch.float16)
image_outputs = model.get_image_features(**inputs)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoProcessor, Blip2Model

<span class="hljs-meta">&gt;&gt;&gt; </span>device = <span class="hljs-string">&quot;cuda&quot;</span> <span class="hljs-keyword">if</span> torch.cuda.is_available() <span class="hljs-keyword">else</span> <span class="hljs-string">&quot;cpu&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>model = Blip2Model.from_pretrained(<span class="hljs-string">&quot;Salesforce/blip2-opt-2.7b&quot;</span>, torch_dtype=torch.float16)

<span class="hljs-meta">&gt;&gt;&gt; </span>model.to(device)
<span class="hljs-meta">&gt;&gt;&gt; </span>processor = AutoProcessor.from_pretrained(<span class="hljs-string">&quot;Salesforce/blip2-opt-2.7b&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;http://images.cocodataset.org/val2017/000000039769.jpg&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = Image.<span class="hljs-built_in">open</span>(requests.get(url, stream=<span class="hljs-literal">True</span>).raw)
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = processor(images=image, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>).to(device, torch.float16)
<span class="hljs-meta">&gt;&gt;&gt; </span>image_outputs = model.get_image_features(**inputs)`}}),{c(){d=a("p"),b=n("Examples:"),u=m(),$(h.$$.fragment)},l(l){d=s(l,"P",{});var p=i(d);b=r(p,"Examples:"),p.forEach(o),u=f(l),w(h.$$.fragment,l)},m(l,p){_(l,d,p),e(d,b),_(l,u,p),B(h,l,p),v=!0},p:Ee,i(l){v||(y(h.$$.fragment,l),v=!0)},o(l){k(h.$$.fragment,l),v=!1},d(l){l&&o(d),l&&o(u),T(h,l)}}}function Om(x){let d,b,u,h,v;return{c(){d=a("p"),b=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),u=a("code"),h=n("Module"),v=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=s(l,"P",{});var p=i(d);b=r(p,"Although the recipe for forward pass needs to be defined within this function, one should call the "),u=s(p,"CODE",{});var E=i(u);h=r(E,"Module"),E.forEach(o),v=r(p,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),p.forEach(o)},m(l,p){_(l,d,p),e(d,b),e(d,u),e(u,h),e(d,v)},d(l){l&&o(d)}}}function Sm(x){let d,b,u,h,v;return h=new je({props:{code:`import torch
from PIL import Image
import requests
from transformers import Blip2Processor, Blip2Model

device = "cuda" if torch.cuda.is_available() else "cpu"

processor = Blip2Processor.from_pretrained("Salesforce/blip2-opt-2.7b")
model = Blip2Model.from_pretrained("Salesforce/blip2-opt-2.7b", torch_dtype=torch.float16)
model.to(device)
url = "http://images.cocodataset.org/val2017/000000039769.jpg"
image = Image.open(requests.get(url, stream=True).raw)
inputs = processor(images=image, return_tensors="pt").to(device, torch.float16)
qformer_outputs = model.get_qformer_features(**inputs)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> Blip2Processor, Blip2Model

<span class="hljs-meta">&gt;&gt;&gt; </span>device = <span class="hljs-string">&quot;cuda&quot;</span> <span class="hljs-keyword">if</span> torch.cuda.is_available() <span class="hljs-keyword">else</span> <span class="hljs-string">&quot;cpu&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>processor = Blip2Processor.from_pretrained(<span class="hljs-string">&quot;Salesforce/blip2-opt-2.7b&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = Blip2Model.from_pretrained(<span class="hljs-string">&quot;Salesforce/blip2-opt-2.7b&quot;</span>, torch_dtype=torch.float16)
<span class="hljs-meta">&gt;&gt;&gt; </span>model.to(device)
<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;http://images.cocodataset.org/val2017/000000039769.jpg&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = Image.<span class="hljs-built_in">open</span>(requests.get(url, stream=<span class="hljs-literal">True</span>).raw)
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = processor(images=image, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>).to(device, torch.float16)
<span class="hljs-meta">&gt;&gt;&gt; </span>qformer_outputs = model.get_qformer_features(**inputs)`}}),{c(){d=a("p"),b=n("Examples:"),u=m(),$(h.$$.fragment)},l(l){d=s(l,"P",{});var p=i(d);b=r(p,"Examples:"),p.forEach(o),u=f(l),w(h.$$.fragment,l)},m(l,p){_(l,d,p),e(d,b),_(l,u,p),B(h,l,p),v=!0},p:Ee,i(l){v||(y(h.$$.fragment,l),v=!0)},o(l){k(h.$$.fragment,l),v=!1},d(l){l&&o(d),l&&o(u),T(h,l)}}}function Dm(x){let d,b,u,h,v;return{c(){d=a("p"),b=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),u=a("code"),h=n("Module"),v=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=s(l,"P",{});var p=i(d);b=r(p,"Although the recipe for forward pass needs to be defined within this function, one should call the "),u=s(p,"CODE",{});var E=i(u);h=r(E,"Module"),E.forEach(o),v=r(p,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),p.forEach(o)},m(l,p){_(l,d,p),e(d,b),e(d,u),e(u,h),e(d,v)},d(l){l&&o(d)}}}function Qm(x){let d,b,u,h,v;return h=new je({props:{code:`from PIL import Image
import requests
from transformers import Blip2Processor, Blip2ForConditionalGeneration
import torch

device = "cuda" if torch.cuda.is_available() else "cpu"

processor = Blip2Processor.from_pretrained("Salesforce/blip2-opt-2.7b")
model = Blip2ForConditionalGeneration.from_pretrained(
    "Salesforce/blip2-opt-2.7b", torch_dtype=torch.float16
)
model.to(device)
url = "http://images.cocodataset.org/val2017/000000039769.jpg"
image = Image.open(requests.get(url, stream=True).raw)

inputs = processor(images=image, return_tensors="pt").to(device, torch.float16)

generated_ids = model.generate(**inputs)
generated_text = processor.batch_decode(generated_ids, skip_special_tokens=True)[0].strip()
print(generated_text)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> Blip2Processor, Blip2ForConditionalGeneration
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span>device = <span class="hljs-string">&quot;cuda&quot;</span> <span class="hljs-keyword">if</span> torch.cuda.is_available() <span class="hljs-keyword">else</span> <span class="hljs-string">&quot;cpu&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>processor = Blip2Processor.from_pretrained(<span class="hljs-string">&quot;Salesforce/blip2-opt-2.7b&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = Blip2ForConditionalGeneration.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;Salesforce/blip2-opt-2.7b&quot;</span>, torch_dtype=torch.float16
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model.to(device)
<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;http://images.cocodataset.org/val2017/000000039769.jpg&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = Image.<span class="hljs-built_in">open</span>(requests.get(url, stream=<span class="hljs-literal">True</span>).raw)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = processor(images=image, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>).to(device, torch.float16)

<span class="hljs-meta">&gt;&gt;&gt; </span>generated_ids = model.generate(**inputs)
<span class="hljs-meta">&gt;&gt;&gt; </span>generated_text = processor.batch_decode(generated_ids, skip_special_tokens=<span class="hljs-literal">True</span>)[<span class="hljs-number">0</span>].strip()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(generated_text)
two cats laying on a couch`}}),{c(){d=a("p"),b=n("Image captioning (without providing a text prompt):"),u=m(),$(h.$$.fragment)},l(l){d=s(l,"P",{});var p=i(d);b=r(p,"Image captioning (without providing a text prompt):"),p.forEach(o),u=f(l),w(h.$$.fragment,l)},m(l,p){_(l,d,p),e(d,b),_(l,u,p),B(h,l,p),v=!0},p:Ee,i(l){v||(y(h.$$.fragment,l),v=!0)},o(l){k(h.$$.fragment,l),v=!1},d(l){l&&o(d),l&&o(u),T(h,l)}}}function Vm(x){let d,b,u,h,v;return h=new je({props:{code:`from PIL import Image
import requests
from transformers import Blip2Processor, Blip2ForConditionalGeneration
import torch

device = "cuda" if torch.cuda.is_available() else "cpu"

processor = Blip2Processor.from_pretrained("Salesforce/blip2-opt-2.7b")
model = Blip2ForConditionalGeneration.from_pretrained(
    "Salesforce/blip2-opt-2.7b", torch_dtype=torch.float16
)
model.to(device)
url = "http://images.cocodataset.org/val2017/000000039769.jpg"
image = Image.open(requests.get(url, stream=True).raw)

prompt = "Question: how many cats are there? Answer:"
inputs = processor(images=image, text=prompt, return_tensors="pt").to(device, torch.float16)

generated_ids = model.generate(**inputs)
generated_text = processor.batch_decode(generated_ids, skip_special_tokens=True)[0].strip()
print(generated_text)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> Blip2Processor, Blip2ForConditionalGeneration
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span>device = <span class="hljs-string">&quot;cuda&quot;</span> <span class="hljs-keyword">if</span> torch.cuda.is_available() <span class="hljs-keyword">else</span> <span class="hljs-string">&quot;cpu&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>processor = Blip2Processor.from_pretrained(<span class="hljs-string">&quot;Salesforce/blip2-opt-2.7b&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = Blip2ForConditionalGeneration.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;Salesforce/blip2-opt-2.7b&quot;</span>, torch_dtype=torch.float16
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model.to(device)
<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;http://images.cocodataset.org/val2017/000000039769.jpg&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = Image.<span class="hljs-built_in">open</span>(requests.get(url, stream=<span class="hljs-literal">True</span>).raw)

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt = <span class="hljs-string">&quot;Question: how many cats are there? Answer:&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = processor(images=image, text=prompt, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>).to(device, torch.float16)

<span class="hljs-meta">&gt;&gt;&gt; </span>generated_ids = model.generate(**inputs)
<span class="hljs-meta">&gt;&gt;&gt; </span>generated_text = processor.batch_decode(generated_ids, skip_special_tokens=<span class="hljs-literal">True</span>)[<span class="hljs-number">0</span>].strip()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(generated_text)
two`}}),{c(){d=a("p"),b=n("Visual question answering (prompt = question):"),u=m(),$(h.$$.fragment)},l(l){d=s(l,"P",{});var p=i(d);b=r(p,"Visual question answering (prompt = question):"),p.forEach(o),u=f(l),w(h.$$.fragment,l)},m(l,p){_(l,d,p),e(d,b),_(l,u,p),B(h,l,p),v=!0},p:Ee,i(l){v||(y(h.$$.fragment,l),v=!0)},o(l){k(h.$$.fragment,l),v=!1},d(l){l&&o(d),l&&o(u),T(h,l)}}}function Nm(x){let d,b,u,h,v,l,p,E,La,qr,se,qe,gn,ht,Aa,un,Oa,Mr,Y,Sa,gt,Da,Qa,ut,Va,Na,zr,vo,Ga,Ir,bo,_n,Wa,Fr,$o,Ha,Lr,Me,_t,Ra,vn,Ua,Ja,Ka,vt,Xa,wo,Ya,Za,Ar,ze,Tc,Or,bt,es,Bo,ts,Sr,Z,os,$t,ns,rs,wt,as,ss,Dr,ie,Ie,bn,Bt,is,$n,ls,Qr,yo,ds,Vr,ko,yt,cs,kt,ps,ms,Nr,To,fs,Gr,le,Fe,wn,Tt,hs,Bn,gs,Wr,A,Pt,us,ee,Po,_s,vs,xo,bs,$s,xt,ws,Bs,ys,de,ks,Co,Ts,Ps,Eo,xs,Cs,Es,Le,js,Ae,Ct,qs,Et,Ms,jo,zs,Is,Hr,ce,Oe,yn,jt,Fs,kn,Ls,Rr,Q,qt,As,pe,Os,qo,Ss,Ds,Mt,Qs,Vs,Ns,me,Gs,Mo,Ws,Hs,zo,Rs,Us,Js,Se,Ur,fe,De,Tn,zt,Ks,Pn,Xs,Jr,V,It,Ys,N,Zs,Io,ei,ti,Ft,oi,ni,Fo,ri,ai,Lo,si,ii,li,he,di,Ao,ci,pi,Oo,mi,fi,hi,Qe,Kr,ge,Ve,xn,Lt,gi,Cn,ui,Xr,O,At,_i,En,vi,bi,S,So,$i,wi,Do,Bi,yi,Qo,ki,Ti,jn,Pi,xi,Vo,Ci,Ei,ji,Ne,Ot,qi,St,Mi,No,zi,Ii,Fi,Ge,Dt,Li,Qt,Ai,Go,Oi,Si,Yr,ue,We,qn,Vt,Di,Mn,Qi,Zr,_e,Nt,Vi,te,Gt,Ni,ve,Gi,Wo,Wi,Hi,zn,Ri,Ui,Ji,He,ea,be,Re,In,Wt,Ki,Fn,Xi,ta,J,Ht,Yi,Ln,Zi,el,oe,Rt,tl,q,ol,An,nl,rl,On,al,sl,Sn,il,ll,Dn,dl,cl,Qn,pl,ml,Vn,fl,hl,Nn,gl,ul,_l,Ut,Jt,vl,Gn,bl,$l,wl,P,Bl,Wn,yl,kl,Hn,Tl,Pl,Rn,xl,Cl,Un,El,jl,Jn,ql,Ml,Kn,zl,Il,Xn,Fl,Ll,Yn,Al,Ol,Zn,Sl,Dl,er,Ql,Vl,tr,Nl,Gl,or,Wl,Hl,nr,Rl,Ul,rr,Jl,Kl,oa,$e,Ue,ar,Kt,Xl,sr,Yl,na,j,Xt,Zl,ir,ed,td,Yt,od,Ho,nd,rd,ad,Zt,sd,eo,id,ld,dd,G,to,cd,we,pd,Ro,md,fd,lr,hd,gd,ud,Je,_d,Ke,vd,W,oo,bd,Be,$d,Uo,wd,Bd,dr,yd,kd,Td,Xe,Pd,Ye,xd,H,no,Cd,ye,Ed,Jo,jd,qd,cr,Md,zd,Id,Ze,Fd,et,Ld,R,ro,Ad,ke,Od,Ko,Sd,Dd,pr,Qd,Vd,Nd,tt,Gd,ot,ra,Te,nt,mr,ao,Wd,fr,Hd,aa,M,so,Rd,hr,Ud,Jd,io,Kd,gr,Xd,Yd,Zd,lo,ec,Xo,tc,oc,nc,co,rc,po,ac,sc,ic,I,mo,lc,Pe,dc,Yo,cc,pc,ur,mc,fc,hc,rt,gc,_r,uc,_c,at,vc,st,bc,it,fo,$c,ho,wc,vr,Bc,yc,sa;return l=new X({}),ht=new X({}),Bt=new X({}),Tt=new X({}),Pt=new z({props:{name:"class transformers.Blip2Config",anchor:"transformers.Blip2Config",parameters:[{name:"vision_config",val:" = None"},{name:"qformer_config",val:" = None"},{name:"text_config",val:" = None"},{name:"num_query_tokens",val:" = 32"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.Blip2Config.vision_config",description:`<strong>vision_config</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
Dictionary of configuration options used to initialize <a href="/docs/transformers/main/en/model_doc/blip-2#transformers.Blip2VisionConfig">Blip2VisionConfig</a>.`,name:"vision_config"},{anchor:"transformers.Blip2Config.qformer_config",description:`<strong>qformer_config</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
Dictionary of configuration options used to initialize <a href="/docs/transformers/main/en/model_doc/blip-2#transformers.Blip2QFormerConfig">Blip2QFormerConfig</a>.`,name:"qformer_config"},{anchor:"transformers.Blip2Config.text_config",description:`<strong>text_config</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
Dictionary of configuration options used to initialize any <a href="/docs/transformers/main/en/main_classes/configuration#transformers.PretrainedConfig">PretrainedConfig</a>.`,name:"text_config"},{anchor:"transformers.Blip2Config.num_query_tokens",description:`<strong>num_query_tokens</strong> (<code>int</code>, <em>optional</em>, defaults to 32) &#x2014;
The number of query tokens passed through the Transformer.`,name:"num_query_tokens"},{anchor:"transformers.Blip2Config.kwargs",description:`<strong>kwargs</strong> (<em>optional</em>) &#x2014;
Dictionary of keyword arguments.`,name:"kwargs"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/blip_2/configuration_blip_2.py#L264"}}),Le=new Ce({props:{anchor:"transformers.Blip2Config.example",$$slots:{default:[Cm]},$$scope:{ctx:x}}}),Ct=new z({props:{name:"from_vision_qformer_text_configs",anchor:"transformers.Blip2Config.from_vision_qformer_text_configs",parameters:[{name:"vision_config",val:": Blip2VisionConfig"},{name:"qformer_config",val:": Blip2QFormerConfig"},{name:"text_config",val:": PretrainedConfig"},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/blip_2/configuration_blip_2.py#L349",returnDescription:`
<p>An instance of a configuration object</p>
`,returnType:`
<p><a
  href="/docs/transformers/main/en/model_doc/blip-2#transformers.Blip2Config"
>Blip2Config</a></p>
`}}),jt=new X({}),qt=new z({props:{name:"class transformers.Blip2VisionConfig",anchor:"transformers.Blip2VisionConfig",parameters:[{name:"hidden_size",val:" = 1408"},{name:"intermediate_size",val:" = 6144"},{name:"projection_dim",val:" = 512"},{name:"num_hidden_layers",val:" = 39"},{name:"num_attention_heads",val:" = 16"},{name:"num_channels",val:" = 3"},{name:"image_size",val:" = 224"},{name:"patch_size",val:" = 14"},{name:"hidden_act",val:" = 'gelu'"},{name:"layer_norm_eps",val:" = 1e-05"},{name:"dropout",val:" = 0.0"},{name:"attention_dropout",val:" = 0.0"},{name:"initializer_range",val:" = 1e-10"},{name:"initializer_factor",val:" = 1.0"},{name:"qkv_bias",val:" = True"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.Blip2VisionConfig.hidden_size",description:`<strong>hidden_size</strong> (<code>int</code>, <em>optional</em>, defaults to 1408) &#x2014;
Dimensionality of the encoder layers and the pooler layer.`,name:"hidden_size"},{anchor:"transformers.Blip2VisionConfig.intermediate_size",description:`<strong>intermediate_size</strong> (<code>int</code>, <em>optional</em>, defaults to 6144) &#x2014;
Dimensionality of the &#x201C;intermediate&#x201D; (i.e., feed-forward) layer in the Transformer encoder.`,name:"intermediate_size"},{anchor:"transformers.Blip2VisionConfig.num_hidden_layers",description:`<strong>num_hidden_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 39) &#x2014;
Number of hidden layers in the Transformer encoder.`,name:"num_hidden_layers"},{anchor:"transformers.Blip2VisionConfig.num_attention_heads",description:`<strong>num_attention_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 16) &#x2014;
Number of attention heads for each attention layer in the Transformer encoder.`,name:"num_attention_heads"},{anchor:"transformers.Blip2VisionConfig.image_size",description:`<strong>image_size</strong> (<code>int</code>, <em>optional</em>, defaults to 224) &#x2014;
The size (resolution) of each image.`,name:"image_size"},{anchor:"transformers.Blip2VisionConfig.patch_size",description:`<strong>patch_size</strong> (<code>int</code>, <em>optional</em>, defaults to 14) &#x2014;
The size (resolution) of each patch.`,name:"patch_size"},{anchor:"transformers.Blip2VisionConfig.hidden_act",description:`<strong>hidden_act</strong> (<code>str</code> or <code>function</code>, <em>optional</em>, defaults to <code>&quot;gelu&quot;</code>) &#x2014;
The non-linear activation function (function or string) in the encoder and pooler. If string, <code>&quot;gelu&quot;</code>,
<code>&quot;relu&quot;</code>, <code>&quot;selu&quot;</code> and <code>&quot;gelu_new&quot;</code> \`<code>&quot;gelu&quot;</code> are supported. layer_norm_eps (<code>float</code>, <em>optional</em>, defaults
to 1e-5): The epsilon used by the layer normalization layers.`,name:"hidden_act"},{anchor:"transformers.Blip2VisionConfig.dropout",description:`<strong>dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The dropout probabilitiy for all fully connected layers in the embeddings, encoder, and pooler.`,name:"dropout"},{anchor:"transformers.Blip2VisionConfig.attention_dropout",description:`<strong>attention_dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The dropout ratio for the attention probabilities.`,name:"attention_dropout"},{anchor:"transformers.Blip2VisionConfig.initializer_range",description:`<strong>initializer_range</strong> (<code>float</code>, <em>optional</em>, defaults to 0.02) &#x2014;
The standard deviation of the truncated_normal_initializer for initializing all weight matrices.`,name:"initializer_range"},{anchor:"transformers.Blip2VisionConfig.initializer_factor",description:`<strong>initializer_factor</strong> (\`float&#x201C;, <em>optional</em>, defaults to 1) &#x2014;
A factor for initializing all weight matrices (should be kept to 1, used internally for initialization
testing).`,name:"initializer_factor"},{anchor:"transformers.Blip2VisionConfig.qkv_bias",description:`<strong>qkv_bias</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to add a bias to the queries and values in the self-attention layers.`,name:"qkv_bias"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/blip_2/configuration_blip_2.py#L34"}}),Se=new Ce({props:{anchor:"transformers.Blip2VisionConfig.example",$$slots:{default:[Em]},$$scope:{ctx:x}}}),zt=new X({}),It=new z({props:{name:"class transformers.Blip2QFormerConfig",anchor:"transformers.Blip2QFormerConfig",parameters:[{name:"vocab_size",val:" = 30522"},{name:"hidden_size",val:" = 768"},{name:"num_hidden_layers",val:" = 12"},{name:"num_attention_heads",val:" = 12"},{name:"intermediate_size",val:" = 3072"},{name:"hidden_act",val:" = 'gelu'"},{name:"hidden_dropout_prob",val:" = 0.1"},{name:"attention_probs_dropout_prob",val:" = 0.1"},{name:"max_position_embeddings",val:" = 512"},{name:"initializer_range",val:" = 0.02"},{name:"layer_norm_eps",val:" = 1e-12"},{name:"pad_token_id",val:" = 0"},{name:"position_embedding_type",val:" = 'absolute'"},{name:"classifier_dropout",val:" = None"},{name:"cross_attention_frequency",val:" = 2"},{name:"encoder_hidden_size",val:" = 1408"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.Blip2QFormerConfig.vocab_size",description:`<strong>vocab_size</strong> (<code>int</code>, <em>optional</em>, defaults to 30522) &#x2014;
Vocabulary size of the Q-Former model. Defines the number of different tokens that can be represented by
the <code>inputs_ids</code> passed when calling the model.`,name:"vocab_size"},{anchor:"transformers.Blip2QFormerConfig.hidden_size",description:`<strong>hidden_size</strong> (<code>int</code>, <em>optional</em>, defaults to 768) &#x2014;
Dimensionality of the encoder layers and the pooler layer.`,name:"hidden_size"},{anchor:"transformers.Blip2QFormerConfig.num_hidden_layers",description:`<strong>num_hidden_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 12) &#x2014;
Number of hidden layers in the Transformer encoder.`,name:"num_hidden_layers"},{anchor:"transformers.Blip2QFormerConfig.num_attention_heads",description:`<strong>num_attention_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 12) &#x2014;
Number of attention heads for each attention layer in the Transformer encoder.`,name:"num_attention_heads"},{anchor:"transformers.Blip2QFormerConfig.intermediate_size",description:`<strong>intermediate_size</strong> (<code>int</code>, <em>optional</em>, defaults to 3072) &#x2014;
Dimensionality of the &#x201C;intermediate&#x201D; (often named feed-forward) layer in the Transformer encoder.`,name:"intermediate_size"},{anchor:"transformers.Blip2QFormerConfig.hidden_act",description:`<strong>hidden_act</strong> (<code>str</code> or <code>Callable</code>, <em>optional</em>, defaults to <code>&quot;gelu&quot;</code>) &#x2014;
The non-linear activation function (function or string) in the encoder and pooler. If string, <code>&quot;gelu&quot;</code>,
<code>&quot;relu&quot;</code>, <code>&quot;silu&quot;</code> and <code>&quot;gelu_new&quot;</code> are supported.`,name:"hidden_act"},{anchor:"transformers.Blip2QFormerConfig.hidden_dropout_prob",description:`<strong>hidden_dropout_prob</strong> (<code>float</code>, <em>optional</em>, defaults to 0.1) &#x2014;
The dropout probability for all fully connected layers in the embeddings, encoder, and pooler.`,name:"hidden_dropout_prob"},{anchor:"transformers.Blip2QFormerConfig.attention_probs_dropout_prob",description:`<strong>attention_probs_dropout_prob</strong> (<code>float</code>, <em>optional</em>, defaults to 0.1) &#x2014;
The dropout ratio for the attention probabilities.`,name:"attention_probs_dropout_prob"},{anchor:"transformers.Blip2QFormerConfig.max_position_embeddings",description:`<strong>max_position_embeddings</strong> (<code>int</code>, <em>optional</em>, defaults to 512) &#x2014;
The maximum sequence length that this model might ever be used with. Typically set this to something large
just in case (e.g., 512 or 1024 or 2048).`,name:"max_position_embeddings"},{anchor:"transformers.Blip2QFormerConfig.initializer_range",description:`<strong>initializer_range</strong> (<code>float</code>, <em>optional</em>, defaults to 0.02) &#x2014;
The standard deviation of the truncated_normal_initializer for initializing all weight matrices.`,name:"initializer_range"},{anchor:"transformers.Blip2QFormerConfig.layer_norm_eps",description:`<strong>layer_norm_eps</strong> (<code>float</code>, <em>optional</em>, defaults to 1e-12) &#x2014;
The epsilon used by the layer normalization layers.`,name:"layer_norm_eps"},{anchor:"transformers.Blip2QFormerConfig.position_embedding_type",description:`<strong>position_embedding_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;absolute&quot;</code>) &#x2014;
Type of position embedding. Choose one of <code>&quot;absolute&quot;</code>, <code>&quot;relative_key&quot;</code>, <code>&quot;relative_key_query&quot;</code>. For
positional embeddings use <code>&quot;absolute&quot;</code>. For more information on <code>&quot;relative_key&quot;</code>, please refer to
<a href="https://arxiv.org/abs/1803.02155" rel="nofollow">Self-Attention with Relative Position Representations (Shaw et al.)</a>.
For more information on <code>&quot;relative_key_query&quot;</code>, please refer to <em>Method 4</em> in <a href="https://arxiv.org/abs/2009.13658" rel="nofollow">Improve Transformer Models
with Better Relative Position Embeddings (Huang et al.)</a>.`,name:"position_embedding_type"},{anchor:"transformers.Blip2QFormerConfig.classifier_dropout",description:`<strong>classifier_dropout</strong> (<code>float</code>, <em>optional</em>) &#x2014;
The dropout ratio for the classification head.`,name:"classifier_dropout"},{anchor:"transformers.Blip2QFormerConfig.cross_attention_frequency",description:`<strong>cross_attention_frequency</strong> (<code>int</code>, <em>optional</em>, defaults to 2) &#x2014;
The frequency of adding cross-attention to the Transformer layers.`,name:"cross_attention_frequency"},{anchor:"transformers.Blip2QFormerConfig.encoder_hidden_size",description:`<strong>encoder_hidden_size</strong> (<code>int</code>, <em>optional</em>, defaults to 1408) &#x2014;
The hidden size of the hidden states for cross-attention.`,name:"encoder_hidden_size"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/blip_2/configuration_blip_2.py#L144"}}),Qe=new Ce({props:{anchor:"transformers.Blip2QFormerConfig.example",$$slots:{default:[jm]},$$scope:{ctx:x}}}),Lt=new X({}),At=new z({props:{name:"class transformers.Blip2Processor",anchor:"transformers.Blip2Processor",parameters:[{name:"image_processor",val:""},{name:"tokenizer",val:""}],parametersDescription:[{anchor:"transformers.Blip2Processor.image_processor",description:`<strong>image_processor</strong> (<code>BlipImageProcessor</code>) &#x2014;
An instance of <a href="/docs/transformers/main/en/model_doc/blip#transformers.BlipImageProcessor">BlipImageProcessor</a>. The image processor is a required input.`,name:"image_processor"},{anchor:"transformers.Blip2Processor.tokenizer",description:"<strong>tokenizer</strong> (<code>AutoTokenizer</code>) &#x2014;\nAn instance of [&#x2018;PreTrainedTokenizer`]. The tokenizer is a required input.",name:"tokenizer"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/blip_2/processing_blip_2.py#L26"}}),Ot=new z({props:{name:"batch_decode",anchor:"transformers.Blip2Processor.batch_decode",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/blip_2/processing_blip_2.py#L133"}}),Dt=new z({props:{name:"decode",anchor:"transformers.Blip2Processor.decode",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/blip_2/processing_blip_2.py#L141"}}),Vt=new X({}),Nt=new z({props:{name:"class transformers.Blip2VisionModel",anchor:"transformers.Blip2VisionModel",parameters:[{name:"config",val:": Blip2VisionConfig"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/blip_2/modeling_blip_2.py#L522"}}),Gt=new z({props:{name:"forward",anchor:"transformers.Blip2VisionModel.forward",parameters:[{name:"pixel_values",val:": typing.Optional[torch.FloatTensor] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.Blip2VisionModel.forward.pixel_values",description:`<strong>pixel_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Pixel values. Pixel values can be obtained using <a href="/docs/transformers/main/en/model_doc/blip-2#transformers.Blip2Processor">Blip2Processor</a>. See <code>Blip2Processor.__call__()</code> for
details.`,name:"pixel_values"},{anchor:"transformers.Blip2VisionModel.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.Blip2VisionModel.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.Blip2VisionModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/main/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/blip_2/modeling_blip_2.py#L537",returnDescription:`
<p>A <a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_outputs.BaseModelOutputWithPooling"
>transformers.modeling_outputs.BaseModelOutputWithPooling</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<code>&lt;class 'transformers.models.blip_2.configuration_blip_2.Blip2VisionConfig'&gt;</code>) and inputs.</p>
<ul>
<li>
<p><strong>last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) \u2014 Sequence of hidden-states at the output of the last layer of the model.</p>
</li>
<li>
<p><strong>pooler_output</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, hidden_size)</code>) \u2014 Last layer hidden-state of the first token of the sequence (classification token) after further processing
through the layers used for the auxiliary pretraining task. E.g. for BERT-family of models, this returns
the classification token after processing through a linear layer and a tanh activation function. The linear
layer weights are trained from the next sentence prediction (classification) objective during pretraining.</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_outputs.BaseModelOutputWithPooling"
>transformers.modeling_outputs.BaseModelOutputWithPooling</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),He=new hn({props:{$$slots:{default:[qm]},$$scope:{ctx:x}}}),Wt=new X({}),Ht=new z({props:{name:"class transformers.Blip2QFormerModel",anchor:"transformers.Blip2QFormerModel",parameters:[{name:"config",val:": Blip2QFormerConfig"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/blip_2/modeling_blip_2.py#L1017"}}),Rt=new z({props:{name:"forward",anchor:"transformers.Blip2QFormerModel.forward",parameters:[{name:"query_embeds",val:""},{name:"attention_mask",val:" = None"},{name:"head_mask",val:" = None"},{name:"encoder_hidden_states",val:" = None"},{name:"encoder_attention_mask",val:" = None"},{name:"past_key_values",val:" = None"},{name:"use_cache",val:" = None"},{name:"output_attentions",val:" = None"},{name:"output_hidden_states",val:" = None"},{name:"return_dict",val:" = None"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/blip_2/modeling_blip_2.py#L1092"}}),Kt=new X({}),Xt=new z({props:{name:"class transformers.Blip2Model",anchor:"transformers.Blip2Model",parameters:[{name:"config",val:": Blip2Config"}],parametersDescription:[{anchor:"transformers.Blip2Model.config",description:`<strong>config</strong> (<a href="/docs/transformers/main/en/model_doc/blip-2#transformers.Blip2Config">Blip2Config</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/blip_2/modeling_blip_2.py#L1217"}}),to=new z({props:{name:"forward",anchor:"transformers.Blip2Model.forward",parameters:[{name:"pixel_values",val:": FloatTensor"},{name:"input_ids",val:": FloatTensor"},{name:"attention_mask",val:": typing.Optional[torch.LongTensor] = None"},{name:"decoder_input_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"decoder_attention_mask",val:": typing.Optional[torch.LongTensor] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"labels",val:": typing.Optional[torch.LongTensor] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.Blip2Model.forward.pixel_values",description:`<strong>pixel_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Pixel values. Pixel values can be obtained using <a href="/docs/transformers/main/en/model_doc/blip-2#transformers.Blip2Processor">Blip2Processor</a>. See <code>Blip2Processor.__call__()</code> for
details.`,name:"pixel_values"},{anchor:"transformers.Blip2Model.forward.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of input sequence tokens in the vocabulary of the language model. Input tokens can optionally be
provided to serve as text prompt, which the language model can continue.</p>
<p>Indices can be obtained using <a href="/docs/transformers/main/en/model_doc/blip-2#transformers.Blip2Processor">Blip2Processor</a>. See <code>Blip2Processor.__call__()</code> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.Blip2Model.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.Tensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.Blip2Model.forward.decoder_input_ids",description:`<strong>decoder_input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, target_sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of decoder input sequence tokens in the vocabulary of the language model. Only relevant in case an
encoder-decoder language model (like T5) is used.</p>
<p>Indices can be obtained using <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details. <a href="../glossary#decoder-input-ids">What are decoder input IDs?</a>`,name:"decoder_input_ids"},{anchor:"transformers.Blip2Model.forward.decoder_attention_mask",description:`<strong>decoder_attention_mask</strong> (<code>torch.BoolTensor</code> of shape <code>(batch_size, target_sequence_length)</code>, <em>optional</em>) &#x2014;
Default behavior: generate a tensor that ignores pad tokens in <code>decoder_input_ids</code>. Causal mask will also
be used by default.</p>
<p>Only relevant in case an encoder-decoder language model (like T5) is used.`,name:"decoder_attention_mask"},{anchor:"transformers.Blip2Model.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.Blip2Model.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.Blip2Model.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/main/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/blip_2/modeling_blip_2.py#L1435",returnDescription:`
<p>A <code>transformers.models.blip_2.modeling_blip_2.Blip2ForConditionalGenerationModelOutput</code> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<code>&lt;class 'transformers.models.blip_2.configuration_blip_2.Blip2VisionConfig'&gt;</code>) and inputs.</p>
<ul>
<li><strong>loss</strong> (<code>torch.FloatTensor</code>, <em>optional</em>, returned when <code>labels</code> is provided, <code>torch.FloatTensor</code> of shape <code>(1,)</code>) \u2014 Language modeling loss from the language model.</li>
<li><strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, config.vocab_size)</code>) \u2014 Prediction scores of the language modeling head of the language model.</li>
<li><strong>vision_outputs</strong> (<code>BaseModelOutputWithPooling</code>) \u2014 Outputs of the vision encoder.</li>
<li><strong>qformer_outputs</strong> (<code>BaseModelOutputWithPoolingAndCrossAttentions</code>) \u2014 Outputs of the Q-Former (Querying Transformer).</li>
<li><strong>language_model_outputs</strong> (<code>CausalLMOutputWithPast</code> or <code>Seq2SeqLMOutput</code>) \u2014 Outputs of the language model.</li>
</ul>
`,returnType:`
<p><code>transformers.models.blip_2.modeling_blip_2.Blip2ForConditionalGenerationModelOutput</code> or <code>tuple(torch.FloatTensor)</code></p>
`}}),Je=new hn({props:{$$slots:{default:[Mm]},$$scope:{ctx:x}}}),Ke=new Ce({props:{anchor:"transformers.Blip2Model.forward.example",$$slots:{default:[zm]},$$scope:{ctx:x}}}),oo=new z({props:{name:"get_text_features",anchor:"transformers.Blip2Model.get_text_features",parameters:[{name:"input_ids",val:": typing.Optional[torch.Tensor] = None"},{name:"attention_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"decoder_input_ids",val:": typing.Optional[torch.Tensor] = None"},{name:"decoder_attention_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"labels",val:": typing.Optional[torch.Tensor] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.Blip2Model.get_text_features.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary. Padding will be ignored by default should you provide
it. Indices can be obtained using <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details. <a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.Blip2Model.get_text_features.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.Tensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.
<a href="../glossary#attention-mask">What are attention masks?</a></li>
</ul>`,name:"attention_mask"},{anchor:"transformers.Blip2Model.get_text_features.decoder_input_ids",description:`<strong>decoder_input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, target_sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of decoder input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#decoder-input-ids">What are decoder input IDs?</a></p>
<p>T5 uses the <code>pad_token_id</code> as the starting token for <code>decoder_input_ids</code> generation. If <code>past_key_values</code>
is used, optionally only the last <code>decoder_input_ids</code> have to be input (see <code>past_key_values</code>).</p>
<p>To know more on how to prepare <code>decoder_input_ids</code> for pretraining take a look at <a href="./t5#training">T5
Training</a>.`,name:"decoder_input_ids"},{anchor:"transformers.Blip2Model.get_text_features.decoder_attention_mask",description:`<strong>decoder_attention_mask</strong> (<code>torch.BoolTensor</code> of shape <code>(batch_size, target_sequence_length)</code>, <em>optional</em>) &#x2014;
Default behavior: generate a tensor that ignores pad tokens in <code>decoder_input_ids</code>. Causal mask will also
be used by default.`,name:"decoder_attention_mask"},{anchor:"transformers.Blip2Model.get_text_features.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.Blip2Model.get_text_features.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.Blip2Model.get_text_features.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/main/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/blip_2/modeling_blip_2.py#L1262",returnDescription:`
<p>The language model outputs. If <code>return_dict=True</code>, the output is a <code>CausalLMOutputWithPast</code> that
contains the language model logits, the past key values and the hidden states if
<code>output_hidden_states=True</code>.</p>
`,returnType:`
<p>text_outputs (<code>CausalLMOutputWithPast</code>, or <code>tuple(torch.FloatTensor)</code> if <code>return_dict=False</code>)</p>
`}}),Xe=new hn({props:{$$slots:{default:[Im]},$$scope:{ctx:x}}}),Ye=new Ce({props:{anchor:"transformers.Blip2Model.get_text_features.example",$$slots:{default:[Fm]},$$scope:{ctx:x}}}),no=new z({props:{name:"get_image_features",anchor:"transformers.Blip2Model.get_image_features",parameters:[{name:"pixel_values",val:": typing.Optional[torch.FloatTensor] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.Blip2Model.get_image_features.pixel_values",description:`<strong>pixel_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Pixel values. Pixel values can be obtained using <a href="/docs/transformers/main/en/model_doc/blip-2#transformers.Blip2Processor">Blip2Processor</a>. See <code>Blip2Processor.__call__()</code> for
details.`,name:"pixel_values"},{anchor:"transformers.Blip2Model.get_image_features.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.Blip2Model.get_image_features.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.Blip2Model.get_image_features.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/main/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/blip_2/modeling_blip_2.py#L1325",returnDescription:`
<p>The vision model outputs. If <code>return_dict=True</code>, the output is a <code>BaseModelOutputWithPooling</code> that
contains the image features, the pooled image features and the hidden states if
<code>output_hidden_states=True</code>.</p>
`,returnType:`
<p>vision_outputs (<code>BaseModelOutputWithPooling</code> or tuple of <code>torch.FloatTensor</code>)</p>
`}}),Ze=new hn({props:{$$slots:{default:[Lm]},$$scope:{ctx:x}}}),et=new Ce({props:{anchor:"transformers.Blip2Model.get_image_features.example",$$slots:{default:[Am]},$$scope:{ctx:x}}}),ro=new z({props:{name:"get_qformer_features",anchor:"transformers.Blip2Model.get_qformer_features",parameters:[{name:"pixel_values",val:": typing.Optional[torch.FloatTensor] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.Blip2Model.get_qformer_features.pixel_values",description:`<strong>pixel_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Pixel values. Pixel values can be obtained using <a href="/docs/transformers/main/en/model_doc/blip-2#transformers.Blip2Processor">Blip2Processor</a>. See <code>Blip2Processor.__call__()</code> for
details.`,name:"pixel_values"},{anchor:"transformers.Blip2Model.get_qformer_features.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of input sequence tokens in the vocabulary of the language model. Input tokens can optionally be
provided to serve as text prompt, which the language model can continue.</p>
<p>Indices can be obtained using <a href="/docs/transformers/main/en/model_doc/blip-2#transformers.Blip2Processor">Blip2Processor</a>. See <code>Blip2Processor.__call__()</code> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.Blip2Model.get_qformer_features.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.Tensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.Blip2Model.get_qformer_features.decoder_input_ids",description:`<strong>decoder_input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, target_sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of decoder input sequence tokens in the vocabulary of the language model. Only relevant in case an
encoder-decoder language model (like T5) is used.</p>
<p>Indices can be obtained using <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details. <a href="../glossary#decoder-input-ids">What are decoder input IDs?</a>`,name:"decoder_input_ids"},{anchor:"transformers.Blip2Model.get_qformer_features.decoder_attention_mask",description:`<strong>decoder_attention_mask</strong> (<code>torch.BoolTensor</code> of shape <code>(batch_size, target_sequence_length)</code>, <em>optional</em>) &#x2014;
Default behavior: generate a tensor that ignores pad tokens in <code>decoder_input_ids</code>. Causal mask will also
be used by default.</p>
<p>Only relevant in case an encoder-decoder language model (like T5) is used.`,name:"decoder_attention_mask"},{anchor:"transformers.Blip2Model.get_qformer_features.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.Blip2Model.get_qformer_features.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.Blip2Model.get_qformer_features.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/main/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/blip_2/modeling_blip_2.py#L1373",returnDescription:`
<p>The vision model outputs. If <code>return_dict=True</code>, the output is a <code>BaseModelOutputWithPooling</code> that
contains the image features, the pooled image features and the hidden states if
<code>output_hidden_states=True</code>.</p>
`,returnType:`
<p>vision_outputs (<code>BaseModelOutputWithPooling</code> or tuple of <code>torch.FloatTensor</code>)</p>
`}}),tt=new hn({props:{$$slots:{default:[Om]},$$scope:{ctx:x}}}),ot=new Ce({props:{anchor:"transformers.Blip2Model.get_qformer_features.example",$$slots:{default:[Sm]},$$scope:{ctx:x}}}),ao=new X({}),so=new z({props:{name:"class transformers.Blip2ForConditionalGeneration",anchor:"transformers.Blip2ForConditionalGeneration",parameters:[{name:"config",val:": Blip2Config"}],parametersDescription:[{anchor:"transformers.Blip2ForConditionalGeneration.config",description:`<strong>config</strong> (<a href="/docs/transformers/main/en/model_doc/blip-2#transformers.Blip2Config">Blip2Config</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/blip_2/modeling_blip_2.py#L1572"}}),mo=new z({props:{name:"forward",anchor:"transformers.Blip2ForConditionalGeneration.forward",parameters:[{name:"pixel_values",val:": FloatTensor"},{name:"input_ids",val:": FloatTensor"},{name:"attention_mask",val:": typing.Optional[torch.LongTensor] = None"},{name:"decoder_input_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"decoder_attention_mask",val:": typing.Optional[torch.LongTensor] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"labels",val:": typing.Optional[torch.LongTensor] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.Blip2ForConditionalGeneration.forward.pixel_values",description:`<strong>pixel_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Pixel values. Pixel values can be obtained using <a href="/docs/transformers/main/en/model_doc/blip-2#transformers.Blip2Processor">Blip2Processor</a>. See <code>Blip2Processor.__call__()</code> for
details.`,name:"pixel_values"},{anchor:"transformers.Blip2ForConditionalGeneration.forward.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of input sequence tokens in the vocabulary of the language model. Input tokens can optionally be
provided to serve as text prompt, which the language model can continue.</p>
<p>Indices can be obtained using <a href="/docs/transformers/main/en/model_doc/blip-2#transformers.Blip2Processor">Blip2Processor</a>. See <code>Blip2Processor.__call__()</code> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.Blip2ForConditionalGeneration.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.Tensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.Blip2ForConditionalGeneration.forward.decoder_input_ids",description:`<strong>decoder_input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, target_sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of decoder input sequence tokens in the vocabulary of the language model. Only relevant in case an
encoder-decoder language model (like T5) is used.</p>
<p>Indices can be obtained using <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details. <a href="../glossary#decoder-input-ids">What are decoder input IDs?</a>`,name:"decoder_input_ids"},{anchor:"transformers.Blip2ForConditionalGeneration.forward.decoder_attention_mask",description:`<strong>decoder_attention_mask</strong> (<code>torch.BoolTensor</code> of shape <code>(batch_size, target_sequence_length)</code>, <em>optional</em>) &#x2014;
Default behavior: generate a tensor that ignores pad tokens in <code>decoder_input_ids</code>. Causal mask will also
be used by default.</p>
<p>Only relevant in case an encoder-decoder language model (like T5) is used.`,name:"decoder_attention_mask"},{anchor:"transformers.Blip2ForConditionalGeneration.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.Blip2ForConditionalGeneration.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.Blip2ForConditionalGeneration.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/main/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/blip_2/modeling_blip_2.py#L1637",returnDescription:`
<p>A <code>transformers.models.blip_2.modeling_blip_2.Blip2ForConditionalGenerationModelOutput</code> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<code>&lt;class 'transformers.models.blip_2.configuration_blip_2.Blip2VisionConfig'&gt;</code>) and inputs.</p>
<ul>
<li><strong>loss</strong> (<code>torch.FloatTensor</code>, <em>optional</em>, returned when <code>labels</code> is provided, <code>torch.FloatTensor</code> of shape <code>(1,)</code>) \u2014 Language modeling loss from the language model.</li>
<li><strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, config.vocab_size)</code>) \u2014 Prediction scores of the language modeling head of the language model.</li>
<li><strong>vision_outputs</strong> (<code>BaseModelOutputWithPooling</code>) \u2014 Outputs of the vision encoder.</li>
<li><strong>qformer_outputs</strong> (<code>BaseModelOutputWithPoolingAndCrossAttentions</code>) \u2014 Outputs of the Q-Former (Querying Transformer).</li>
<li><strong>language_model_outputs</strong> (<code>CausalLMOutputWithPast</code> or <code>Seq2SeqLMOutput</code>) \u2014 Outputs of the language model.</li>
</ul>
`,returnType:`
<p><code>transformers.models.blip_2.modeling_blip_2.Blip2ForConditionalGenerationModelOutput</code> or <code>tuple(torch.FloatTensor)</code></p>
`}}),rt=new hn({props:{$$slots:{default:[Dm]},$$scope:{ctx:x}}}),at=new Ce({props:{anchor:"transformers.Blip2ForConditionalGeneration.forward.example",$$slots:{default:[Qm]},$$scope:{ctx:x}}}),st=new Ce({props:{anchor:"transformers.Blip2ForConditionalGeneration.forward.example-2",$$slots:{default:[Vm]},$$scope:{ctx:x}}}),fo=new z({props:{name:"generate",anchor:"transformers.Blip2ForConditionalGeneration.generate",parameters:[{name:"pixel_values",val:": FloatTensor"},{name:"input_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"attention_mask",val:": typing.Optional[torch.LongTensor] = None"},{name:"**generate_kwargs",val:""}],parametersDescription:[{anchor:"transformers.Blip2ForConditionalGeneration.generate.pixel_values",description:`<strong>pixel_values</strong> (<code>torch.FloatTensor</code> of shape (batch_size, num_channels, height, width)) &#x2014;
Input images to be processed.`,name:"pixel_values"},{anchor:"transformers.Blip2ForConditionalGeneration.generate.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape (batch_size, sequence_length), <em>optional</em>) &#x2014;
The sequence used as a prompt for the generation.`,name:"input_ids"},{anchor:"transformers.Blip2ForConditionalGeneration.generate.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.LongTensor</code> of shape (batch_size, sequence_length), <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices`,name:"attention_mask"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/blip_2/modeling_blip_2.py#L1797",returnDescription:`
<p>A list of strings of length batch_size * num_captions.</p>
`,returnType:`
<p>captions (list)</p>
`}}),{c(){d=a("meta"),b=m(),u=a("h1"),h=a("a"),v=a("span"),$(l.$$.fragment),p=m(),E=a("span"),La=n("BLIP-2"),qr=m(),se=a("h2"),qe=a("a"),gn=a("span"),$(ht.$$.fragment),Aa=m(),un=a("span"),Oa=n("Overview"),Mr=m(),Y=a("p"),Sa=n("The BLIP-2 model was proposed in "),gt=a("a"),Da=n("BLIP-2: Bootstrapping Language-Image Pre-training with Frozen Image Encoders and Large Language Models"),Qa=n(` by
Junnan Li, Dongxu Li, Silvio Savarese, Steven Hoi. BLIP-2 leverages frozen pre-trained image encoders and large language models (LLMs) by training a lightweight, 12-layer Transformer
encoder in between them, achieving state-of-the-art performance on various vision-language tasks. Most notably, BLIP-2 improves upon `),ut=a("a"),Va=n("Flamingo"),Na=n(`, an 80 billion parameter model, by 8.7%
on zero-shot VQAv2 with 54x fewer trainable parameters.`),zr=m(),vo=a("p"),Ga=n("The abstract from the paper is the following:"),Ir=m(),bo=a("p"),_n=a("em"),Wa=n("The cost of vision-and-language pre-training has become increasingly prohibitive due to end-to-end training of large-scale models. This paper proposes BLIP-2, a generic and efficient pre-training strategy that bootstraps vision-language pre-training from off-the-shelf frozen pre-trained image encoders and frozen large language models. BLIP-2 bridges the modality gap with a lightweight Querying Transformer, which is pre-trained in two stages. The first stage bootstraps vision-language representation learning from a frozen image encoder. The second stage bootstraps vision-to-language generative learning from a frozen language model. BLIP-2 achieves state-of-the-art performance on various vision-language tasks, despite having significantly fewer trainable parameters than existing methods. For example, our model outperforms Flamingo80B by 8.7% on zero-shot VQAv2 with 54x fewer trainable parameters. We also demonstrate the model\u2019s emerging capabilities of zero-shot image-to-text generation that can follow natural language instructions."),Fr=m(),$o=a("p"),Ha=n("Tips:"),Lr=m(),Me=a("ul"),_t=a("li"),Ra=n("BLIP-2 can be used for conditional text generation given an image and an optional text prompt. At inference time, it\u2019s recommended to use the "),vn=a("code"),Ua=n("generate"),Ja=n(" method."),Ka=m(),vt=a("li"),Xa=n("One can use "),wo=a("a"),Ya=n("Blip2Processor"),Za=n(" to prepare images for the model, and decode the predicted tokens ID\u2019s back to text."),Ar=m(),ze=a("img"),Or=m(),bt=a("small"),es=n("BLIP-2 architecture. Taken from the "),Bo=a("a"),ts=n("original paper."),Sr=m(),Z=a("p"),os=n("This model was contributed by "),$t=a("a"),ns=n("nielsr"),rs=n(`.
The original code can be found `),wt=a("a"),as=n("here"),ss=n("."),Dr=m(),ie=a("h2"),Ie=a("a"),bn=a("span"),$(Bt.$$.fragment),is=m(),$n=a("span"),ls=n("Resources"),Qr=m(),yo=a("p"),ds=n("A list of official Hugging Face and community (indicated by \u{1F30E}) resources to help you get started with BLIP-2."),Vr=m(),ko=a("ul"),yt=a("li"),cs=n("Demo notebooks for BLIP-2 for image captioning, visual question answering (VQA) and chat-like conversations can be found "),kt=a("a"),ps=n("here"),ms=n("."),Nr=m(),To=a("p"),fs=n("If you\u2019re interested in submitting a resource to be included here, please feel free to open a Pull Request and we\u2019ll review it! The resource should ideally demonstrate something new instead of duplicating an existing resource."),Gr=m(),le=a("h2"),Fe=a("a"),wn=a("span"),$(Tt.$$.fragment),hs=m(),Bn=a("span"),gs=n("Blip2Config"),Wr=m(),A=a("div"),$(Pt.$$.fragment),us=m(),ee=a("p"),Po=a("a"),_s=n("Blip2Config"),vs=n(" is the configuration class to store the configuration of a "),xo=a("a"),bs=n("Blip2ForConditionalGeneration"),$s=n(`. It is
used to instantiate a BLIP-2 model according to the specified arguments, defining the vision model, Q-Former model
and language model configs. Instantiating a configuration with the defaults will yield a similar configuration to
that of the BLIP-2 `),xt=a("a"),ws=n("Salesforce/blip2-opt-2.7b"),Bs=n(" architecture."),ys=m(),de=a("p"),ks=n("Configuration objects inherit from "),Co=a("a"),Ts=n("PretrainedConfig"),Ps=n(` and can be used to control the model outputs. Read the
documentation from `),Eo=a("a"),xs=n("PretrainedConfig"),Cs=n(" for more information."),Es=m(),$(Le.$$.fragment),js=m(),Ae=a("div"),$(Ct.$$.fragment),qs=m(),Et=a("p"),Ms=n("Instantiate a "),jo=a("a"),zs=n("Blip2Config"),Is=n(` (or a derived class) from a BLIP-2 vision model, Q-Former and language model
configurations.`),Hr=m(),ce=a("h2"),Oe=a("a"),yn=a("span"),$(jt.$$.fragment),Fs=m(),kn=a("span"),Ls=n("Blip2VisionConfig"),Rr=m(),Q=a("div"),$(qt.$$.fragment),As=m(),pe=a("p"),Os=n("This is the configuration class to store the configuration of a "),qo=a("a"),Ss=n("Blip2VisionModel"),Ds=n(`. It is used to instantiate a
BLIP-2 vision encoder according to the specified arguments, defining the model architecture. Instantiating a
configuration defaults will yield a similar configuration to that of the BLIP-2
`),Mt=a("a"),Qs=n("Salesforce/blip2-opt-2.7b"),Vs=n(" architecture."),Ns=m(),me=a("p"),Gs=n("Configuration objects inherit from "),Mo=a("a"),Ws=n("PretrainedConfig"),Hs=n(` and can be used to control the model outputs. Read the
documentation from `),zo=a("a"),Rs=n("PretrainedConfig"),Us=n(" for more information."),Js=m(),$(Se.$$.fragment),Ur=m(),fe=a("h2"),De=a("a"),Tn=a("span"),$(zt.$$.fragment),Ks=m(),Pn=a("span"),Xs=n("Blip2QFormerConfig"),Jr=m(),V=a("div"),$(It.$$.fragment),Ys=m(),N=a("p"),Zs=n("This is the configuration class to store the configuration of a "),Io=a("a"),ei=n("Blip2QFormerModel"),ti=n(`. It is used to instantiate a
BLIP-2 Querying Transformer (Q-Former) model according to the specified arguments, defining the model architecture.
Instantiating a configuration with the defaults will yield a similar configuration to that of the BLIP-2
`),Ft=a("a"),oi=n("Salesforce/blip2-opt-2.7b"),ni=n(` architecture. Configuration objects
inherit from `),Fo=a("a"),ri=n("PretrainedConfig"),ai=n(` and can be used to control the model outputs. Read the documentation from
`),Lo=a("a"),si=n("PretrainedConfig"),ii=n(" for more information."),li=m(),he=a("p"),di=n("Note that "),Ao=a("a"),ci=n("Blip2QFormerModel"),pi=n(" is very similar to "),Oo=a("a"),mi=n("BertLMHeadModel"),fi=n(" with interleaved cross-attention."),hi=m(),$(Qe.$$.fragment),Kr=m(),ge=a("h2"),Ve=a("a"),xn=a("span"),$(Lt.$$.fragment),gi=m(),Cn=a("span"),ui=n("Blip2Processor"),Xr=m(),O=a("div"),$(At.$$.fragment),_i=m(),En=a("p"),vi=n("Constructs a BLIP-2 processor which wraps a BLIP image processor and an OPT/T5 tokenizer into a single processor."),bi=m(),S=a("p"),So=a("a"),$i=n("BlipProcessor"),wi=n(" offers all the functionalities of "),Do=a("a"),Bi=n("BlipImageProcessor"),yi=n(" and "),Qo=a("a"),ki=n("AutoTokenizer"),Ti=n(`. See the docstring
of `),jn=a("code"),Pi=n("__call__()"),xi=n(" and "),Vo=a("a"),Ci=n("decode()"),Ei=n(" for more information."),ji=m(),Ne=a("div"),$(Ot.$$.fragment),qi=m(),St=a("p"),Mi=n("This method forwards all its arguments to PreTrainedTokenizer\u2019s "),No=a("a"),zi=n("batch_decode()"),Ii=n(`. Please
refer to the docstring of this method for more information.`),Fi=m(),Ge=a("div"),$(Dt.$$.fragment),Li=m(),Qt=a("p"),Ai=n("This method forwards all its arguments to PreTrainedTokenizer\u2019s "),Go=a("a"),Oi=n("decode()"),Si=n(`. Please refer
to the docstring of this method for more information.`),Yr=m(),ue=a("h2"),We=a("a"),qn=a("span"),$(Vt.$$.fragment),Di=m(),Mn=a("span"),Qi=n("Blip2VisionModel"),Zr=m(),_e=a("div"),$(Nt.$$.fragment),Vi=m(),te=a("div"),$(Gt.$$.fragment),Ni=m(),ve=a("p"),Gi=n("The "),Wo=a("a"),Wi=n("Blip2VisionModel"),Hi=n(" forward method, overrides the "),zn=a("code"),Ri=n("__call__"),Ui=n(" special method."),Ji=m(),$(He.$$.fragment),ea=m(),be=a("h2"),Re=a("a"),In=a("span"),$(Wt.$$.fragment),Ki=m(),Fn=a("span"),Xi=n("Blip2QFormerModel"),ta=m(),J=a("div"),$(Ht.$$.fragment),Yi=m(),Ln=a("p"),Zi=n("Querying Transformer (Q-Former), used in BLIP-2."),el=m(),oe=a("div"),$(Rt.$$.fragment),tl=m(),q=a("p"),ol=n("encoder_hidden_states  ("),An=a("code"),nl=n("torch.FloatTensor"),rl=n(" of shape "),On=a("code"),al=n("(batch_size, sequence_length, hidden_size)"),sl=n(", "),Sn=a("code"),il=n("optional"),ll=n(`):
Sequence of hidden-states at the output of the last layer of the encoder. Used in the cross-attention if
the model is configured as a decoder.
encoder_attention_mask (`),Dn=a("code"),dl=n("torch.FloatTensor"),cl=n(" of shape "),Qn=a("code"),pl=n("(batch_size, sequence_length)"),ml=n(", "),Vn=a("code"),fl=n("optional"),hl=n(`):
Mask to avoid performing attention on the padding token indices of the encoder input. This mask is used in
the cross-attention if the model is configured as a decoder. Mask values selected in `),Nn=a("code"),gl=n("[0, 1]"),ul=n(":"),_l=m(),Ut=a("ul"),Jt=a("li"),vl=n("1 for tokens that are "),Gn=a("strong"),bl=n("not masked"),$l=n(","),wl=m(),P=a("li"),Bl=n("0 for tokens that are "),Wn=a("strong"),yl=n("masked"),kl=n(`.
past_key_values (`),Hn=a("code"),Tl=n("tuple(tuple(torch.FloatTensor))"),Pl=n(" of length "),Rn=a("code"),xl=n("config.n_layers"),Cl=n(` with each tuple having 4 tensors of:
shape `),Un=a("code"),El=n("(batch_size, num_heads, sequence_length - 1, embed_size_per_head)"),jl=n(`): Contains precomputed key and
value hidden states of the attention blocks. Can be used to speed up decoding. If `),Jn=a("code"),ql=n("past_key_values"),Ml=n(` are
used, the user can optionally input only the last `),Kn=a("code"),zl=n("decoder_input_ids"),Il=n(` (those that don\u2019t have their past key
value states given to this model) of shape `),Xn=a("code"),Fl=n("(batch_size, 1)"),Ll=n(" instead of all "),Yn=a("code"),Al=n("decoder_input_ids"),Ol=n(` of shape
`),Zn=a("code"),Sl=n("(batch_size, sequence_length)"),Dl=n(`.
use_cache (`),er=a("code"),Ql=n("bool"),Vl=n(", "),tr=a("code"),Nl=n("optional"),Gl=n(`):
If set to `),or=a("code"),Wl=n("True"),Hl=n(", "),nr=a("code"),Rl=n("past_key_values"),Ul=n(` key value states are returned and can be used to speed up decoding (see
`),rr=a("code"),Jl=n("past_key_values"),Kl=n(")."),oa=m(),$e=a("h2"),Ue=a("a"),ar=a("span"),$(Kt.$$.fragment),Xl=m(),sr=a("span"),Yl=n("Blip2Model"),na=m(),j=a("div"),$(Xt.$$.fragment),Zl=m(),ir=a("p"),ed=n(`BLIP-2 Model for generating text and image features. The model consists of a vision encoder, Querying Transformer
(Q-Former) and a language model.`),td=m(),Yt=a("p"),od=n("This model inherits from "),Ho=a("a"),nd=n("PreTrainedModel"),rd=n(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),ad=m(),Zt=a("p"),sd=n("This model is also a PyTorch "),eo=a("a"),id=n("torch.nn.Module"),ld=n(` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),dd=m(),G=a("div"),$(to.$$.fragment),cd=m(),we=a("p"),pd=n("The "),Ro=a("a"),md=n("Blip2Model"),fd=n(" forward method, overrides the "),lr=a("code"),hd=n("__call__"),gd=n(" special method."),ud=m(),$(Je.$$.fragment),_d=m(),$(Ke.$$.fragment),vd=m(),W=a("div"),$(oo.$$.fragment),bd=m(),Be=a("p"),$d=n("The "),Uo=a("a"),wd=n("Blip2Model"),Bd=n(" forward method, overrides the "),dr=a("code"),yd=n("__call__"),kd=n(" special method."),Td=m(),$(Xe.$$.fragment),Pd=m(),$(Ye.$$.fragment),xd=m(),H=a("div"),$(no.$$.fragment),Cd=m(),ye=a("p"),Ed=n("The "),Jo=a("a"),jd=n("Blip2Model"),qd=n(" forward method, overrides the "),cr=a("code"),Md=n("__call__"),zd=n(" special method."),Id=m(),$(Ze.$$.fragment),Fd=m(),$(et.$$.fragment),Ld=m(),R=a("div"),$(ro.$$.fragment),Ad=m(),ke=a("p"),Od=n("The "),Ko=a("a"),Sd=n("Blip2Model"),Dd=n(" forward method, overrides the "),pr=a("code"),Qd=n("__call__"),Vd=n(" special method."),Nd=m(),$(tt.$$.fragment),Gd=m(),$(ot.$$.fragment),ra=m(),Te=a("h2"),nt=a("a"),mr=a("span"),$(ao.$$.fragment),Wd=m(),fr=a("span"),Hd=n("Blip2ForConditionalGeneration"),aa=m(),M=a("div"),$(so.$$.fragment),Rd=m(),hr=a("p"),Ud=n(`BLIP-2 Model for generating text given an image and an optional text prompt. The model consists of a vision
encoder, Querying Transformer (Q-Former) and a language model.`),Jd=m(),io=a("p"),Kd=n("One can optionally pass "),gr=a("code"),Xd=n("input_ids"),Yd=n(` to the model, which serve as a text prompt, to make the language model continue
the prompt. Otherwise, the language model starts generating text from the [BOS] (beginning-of-sequence) token.`),Zd=m(),lo=a("p"),ec=n("This model inherits from "),Xo=a("a"),tc=n("PreTrainedModel"),oc=n(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),nc=m(),co=a("p"),rc=n("This model is also a PyTorch "),po=a("a"),ac=n("torch.nn.Module"),sc=n(` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),ic=m(),I=a("div"),$(mo.$$.fragment),lc=m(),Pe=a("p"),dc=n("The "),Yo=a("a"),cc=n("Blip2ForConditionalGeneration"),pc=n(" forward method, overrides the "),ur=a("code"),mc=n("__call__"),fc=n(" special method."),hc=m(),$(rt.$$.fragment),gc=m(),_r=a("p"),uc=n("Examples:"),_c=m(),$(at.$$.fragment),vc=m(),$(st.$$.fragment),bc=m(),it=a("div"),$(fo.$$.fragment),$c=m(),ho=a("p"),wc=n("Overrides "),vr=a("code"),Bc=n("generate"),yc=n(" function to be able to use the model as a conditional generator."),this.h()},l(t){const g=Tm('[data-svelte="svelte-1phssyn"]',document.head);d=s(g,"META",{name:!0,content:!0}),g.forEach(o),b=f(t),u=s(t,"H1",{class:!0});var go=i(u);h=s(go,"A",{id:!0,class:!0,href:!0});var br=i(h);v=s(br,"SPAN",{});var $r=i(v);w(l.$$.fragment,$r),$r.forEach(o),br.forEach(o),p=f(go),E=s(go,"SPAN",{});var wr=i(E);La=r(wr,"BLIP-2"),wr.forEach(o),go.forEach(o),qr=f(t),se=s(t,"H2",{class:!0});var uo=i(se);qe=s(uo,"A",{id:!0,class:!0,href:!0});var Br=i(qe);gn=s(Br,"SPAN",{});var yr=i(gn);w(ht.$$.fragment,yr),yr.forEach(o),Br.forEach(o),Aa=f(uo),un=s(uo,"SPAN",{});var kr=i(un);Oa=r(kr,"Overview"),kr.forEach(o),uo.forEach(o),Mr=f(t),Y=s(t,"P",{});var xe=i(Y);Sa=r(xe,"The BLIP-2 model was proposed in "),gt=s(xe,"A",{href:!0,rel:!0});var Tr=i(gt);Da=r(Tr,"BLIP-2: Bootstrapping Language-Image Pre-training with Frozen Image Encoders and Large Language Models"),Tr.forEach(o),Qa=r(xe,` by
Junnan Li, Dongxu Li, Silvio Savarese, Steven Hoi. BLIP-2 leverages frozen pre-trained image encoders and large language models (LLMs) by training a lightweight, 12-layer Transformer
encoder in between them, achieving state-of-the-art performance on various vision-language tasks. Most notably, BLIP-2 improves upon `),ut=s(xe,"A",{href:!0,rel:!0});var Pr=i(ut);Va=r(Pr,"Flamingo"),Pr.forEach(o),Na=r(xe,`, an 80 billion parameter model, by 8.7%
on zero-shot VQAv2 with 54x fewer trainable parameters.`),xe.forEach(o),zr=f(t),vo=s(t,"P",{});var xr=i(vo);Ga=r(xr,"The abstract from the paper is the following:"),xr.forEach(o),Ir=f(t),bo=s(t,"P",{});var Cr=i(bo);_n=s(Cr,"EM",{});var Er=i(_n);Wa=r(Er,"The cost of vision-and-language pre-training has become increasingly prohibitive due to end-to-end training of large-scale models. This paper proposes BLIP-2, a generic and efficient pre-training strategy that bootstraps vision-language pre-training from off-the-shelf frozen pre-trained image encoders and frozen large language models. BLIP-2 bridges the modality gap with a lightweight Querying Transformer, which is pre-trained in two stages. The first stage bootstraps vision-language representation learning from a frozen image encoder. The second stage bootstraps vision-to-language generative learning from a frozen language model. BLIP-2 achieves state-of-the-art performance on various vision-language tasks, despite having significantly fewer trainable parameters than existing methods. For example, our model outperforms Flamingo80B by 8.7% on zero-shot VQAv2 with 54x fewer trainable parameters. We also demonstrate the model\u2019s emerging capabilities of zero-shot image-to-text generation that can follow natural language instructions."),Er.forEach(o),Cr.forEach(o),Fr=f(t),$o=s(t,"P",{});var jr=i($o);Ha=r(jr,"Tips:"),jr.forEach(o),Lr=f(t),Me=s(t,"UL",{});var ia=i(Me);_t=s(ia,"LI",{});var la=i(_t);Ra=r(la,"BLIP-2 can be used for conditional text generation given an image and an optional text prompt. At inference time, it\u2019s recommended to use the "),vn=s(la,"CODE",{});var Pc=i(vn);Ua=r(Pc,"generate"),Pc.forEach(o),Ja=r(la," method."),la.forEach(o),Ka=f(ia),vt=s(ia,"LI",{});var da=i(vt);Xa=r(da,"One can use "),wo=s(da,"A",{href:!0});var xc=i(wo);Ya=r(xc,"Blip2Processor"),xc.forEach(o),Za=r(da," to prepare images for the model, and decode the predicted tokens ID\u2019s back to text."),da.forEach(o),ia.forEach(o),Ar=f(t),ze=s(t,"IMG",{src:!0,alt:!0,width:!0}),Or=f(t),bt=s(t,"SMALL",{});var kc=i(bt);es=r(kc,"BLIP-2 architecture. Taken from the "),Bo=s(kc,"A",{href:!0});var Cc=i(Bo);ts=r(Cc,"original paper."),Cc.forEach(o),kc.forEach(o),Sr=f(t),Z=s(t,"P",{});var Zo=i(Z);os=r(Zo,"This model was contributed by "),$t=s(Zo,"A",{href:!0,rel:!0});var Ec=i($t);ns=r(Ec,"nielsr"),Ec.forEach(o),rs=r(Zo,`.
The original code can be found `),wt=s(Zo,"A",{href:!0,rel:!0});var jc=i(wt);as=r(jc,"here"),jc.forEach(o),ss=r(Zo,"."),Zo.forEach(o),Dr=f(t),ie=s(t,"H2",{class:!0});var ca=i(ie);Ie=s(ca,"A",{id:!0,class:!0,href:!0});var qc=i(Ie);bn=s(qc,"SPAN",{});var Mc=i(bn);w(Bt.$$.fragment,Mc),Mc.forEach(o),qc.forEach(o),is=f(ca),$n=s(ca,"SPAN",{});var zc=i($n);ls=r(zc,"Resources"),zc.forEach(o),ca.forEach(o),Qr=f(t),yo=s(t,"P",{});var Ic=i(yo);ds=r(Ic,"A list of official Hugging Face and community (indicated by \u{1F30E}) resources to help you get started with BLIP-2."),Ic.forEach(o),Vr=f(t),ko=s(t,"UL",{});var Fc=i(ko);yt=s(Fc,"LI",{});var pa=i(yt);cs=r(pa,"Demo notebooks for BLIP-2 for image captioning, visual question answering (VQA) and chat-like conversations can be found "),kt=s(pa,"A",{href:!0,rel:!0});var Lc=i(kt);ps=r(Lc,"here"),Lc.forEach(o),ms=r(pa,"."),pa.forEach(o),Fc.forEach(o),Nr=f(t),To=s(t,"P",{});var Ac=i(To);fs=r(Ac,"If you\u2019re interested in submitting a resource to be included here, please feel free to open a Pull Request and we\u2019ll review it! The resource should ideally demonstrate something new instead of duplicating an existing resource."),Ac.forEach(o),Gr=f(t),le=s(t,"H2",{class:!0});var ma=i(le);Fe=s(ma,"A",{id:!0,class:!0,href:!0});var Oc=i(Fe);wn=s(Oc,"SPAN",{});var Sc=i(wn);w(Tt.$$.fragment,Sc),Sc.forEach(o),Oc.forEach(o),hs=f(ma),Bn=s(ma,"SPAN",{});var Dc=i(Bn);gs=r(Dc,"Blip2Config"),Dc.forEach(o),ma.forEach(o),Wr=f(t),A=s(t,"DIV",{class:!0});var ne=i(A);w(Pt.$$.fragment,ne),us=f(ne),ee=s(ne,"P",{});var _o=i(ee);Po=s(_o,"A",{href:!0});var Qc=i(Po);_s=r(Qc,"Blip2Config"),Qc.forEach(o),vs=r(_o," is the configuration class to store the configuration of a "),xo=s(_o,"A",{href:!0});var Vc=i(xo);bs=r(Vc,"Blip2ForConditionalGeneration"),Vc.forEach(o),$s=r(_o,`. It is
used to instantiate a BLIP-2 model according to the specified arguments, defining the vision model, Q-Former model
and language model configs. Instantiating a configuration with the defaults will yield a similar configuration to
that of the BLIP-2 `),xt=s(_o,"A",{href:!0,rel:!0});var Nc=i(xt);ws=r(Nc,"Salesforce/blip2-opt-2.7b"),Nc.forEach(o),Bs=r(_o," architecture."),_o.forEach(o),ys=f(ne),de=s(ne,"P",{});var en=i(de);ks=r(en,"Configuration objects inherit from "),Co=s(en,"A",{href:!0});var Gc=i(Co);Ts=r(Gc,"PretrainedConfig"),Gc.forEach(o),Ps=r(en,` and can be used to control the model outputs. Read the
documentation from `),Eo=s(en,"A",{href:!0});var Wc=i(Eo);xs=r(Wc,"PretrainedConfig"),Wc.forEach(o),Cs=r(en," for more information."),en.forEach(o),Es=f(ne),w(Le.$$.fragment,ne),js=f(ne),Ae=s(ne,"DIV",{class:!0});var fa=i(Ae);w(Ct.$$.fragment,fa),qs=f(fa),Et=s(fa,"P",{});var ha=i(Et);Ms=r(ha,"Instantiate a "),jo=s(ha,"A",{href:!0});var Hc=i(jo);zs=r(Hc,"Blip2Config"),Hc.forEach(o),Is=r(ha,` (or a derived class) from a BLIP-2 vision model, Q-Former and language model
configurations.`),ha.forEach(o),fa.forEach(o),ne.forEach(o),Hr=f(t),ce=s(t,"H2",{class:!0});var ga=i(ce);Oe=s(ga,"A",{id:!0,class:!0,href:!0});var Rc=i(Oe);yn=s(Rc,"SPAN",{});var Uc=i(yn);w(jt.$$.fragment,Uc),Uc.forEach(o),Rc.forEach(o),Fs=f(ga),kn=s(ga,"SPAN",{});var Jc=i(kn);Ls=r(Jc,"Blip2VisionConfig"),Jc.forEach(o),ga.forEach(o),Rr=f(t),Q=s(t,"DIV",{class:!0});var lt=i(Q);w(qt.$$.fragment,lt),As=f(lt),pe=s(lt,"P",{});var tn=i(pe);Os=r(tn,"This is the configuration class to store the configuration of a "),qo=s(tn,"A",{href:!0});var Kc=i(qo);Ss=r(Kc,"Blip2VisionModel"),Kc.forEach(o),Ds=r(tn,`. It is used to instantiate a
BLIP-2 vision encoder according to the specified arguments, defining the model architecture. Instantiating a
configuration defaults will yield a similar configuration to that of the BLIP-2
`),Mt=s(tn,"A",{href:!0,rel:!0});var Xc=i(Mt);Qs=r(Xc,"Salesforce/blip2-opt-2.7b"),Xc.forEach(o),Vs=r(tn," architecture."),tn.forEach(o),Ns=f(lt),me=s(lt,"P",{});var on=i(me);Gs=r(on,"Configuration objects inherit from "),Mo=s(on,"A",{href:!0});var Yc=i(Mo);Ws=r(Yc,"PretrainedConfig"),Yc.forEach(o),Hs=r(on,` and can be used to control the model outputs. Read the
documentation from `),zo=s(on,"A",{href:!0});var Zc=i(zo);Rs=r(Zc,"PretrainedConfig"),Zc.forEach(o),Us=r(on," for more information."),on.forEach(o),Js=f(lt),w(Se.$$.fragment,lt),lt.forEach(o),Ur=f(t),fe=s(t,"H2",{class:!0});var ua=i(fe);De=s(ua,"A",{id:!0,class:!0,href:!0});var ep=i(De);Tn=s(ep,"SPAN",{});var tp=i(Tn);w(zt.$$.fragment,tp),tp.forEach(o),ep.forEach(o),Ks=f(ua),Pn=s(ua,"SPAN",{});var op=i(Pn);Xs=r(op,"Blip2QFormerConfig"),op.forEach(o),ua.forEach(o),Jr=f(t),V=s(t,"DIV",{class:!0});var dt=i(V);w(It.$$.fragment,dt),Ys=f(dt),N=s(dt,"P",{});var re=i(N);Zs=r(re,"This is the configuration class to store the configuration of a "),Io=s(re,"A",{href:!0});var np=i(Io);ei=r(np,"Blip2QFormerModel"),np.forEach(o),ti=r(re,`. It is used to instantiate a
BLIP-2 Querying Transformer (Q-Former) model according to the specified arguments, defining the model architecture.
Instantiating a configuration with the defaults will yield a similar configuration to that of the BLIP-2
`),Ft=s(re,"A",{href:!0,rel:!0});var rp=i(Ft);oi=r(rp,"Salesforce/blip2-opt-2.7b"),rp.forEach(o),ni=r(re,` architecture. Configuration objects
inherit from `),Fo=s(re,"A",{href:!0});var ap=i(Fo);ri=r(ap,"PretrainedConfig"),ap.forEach(o),ai=r(re,` and can be used to control the model outputs. Read the documentation from
`),Lo=s(re,"A",{href:!0});var sp=i(Lo);si=r(sp,"PretrainedConfig"),sp.forEach(o),ii=r(re," for more information."),re.forEach(o),li=f(dt),he=s(dt,"P",{});var nn=i(he);di=r(nn,"Note that "),Ao=s(nn,"A",{href:!0});var ip=i(Ao);ci=r(ip,"Blip2QFormerModel"),ip.forEach(o),pi=r(nn," is very similar to "),Oo=s(nn,"A",{href:!0});var lp=i(Oo);mi=r(lp,"BertLMHeadModel"),lp.forEach(o),fi=r(nn," with interleaved cross-attention."),nn.forEach(o),hi=f(dt),w(Qe.$$.fragment,dt),dt.forEach(o),Kr=f(t),ge=s(t,"H2",{class:!0});var _a=i(ge);Ve=s(_a,"A",{id:!0,class:!0,href:!0});var dp=i(Ve);xn=s(dp,"SPAN",{});var cp=i(xn);w(Lt.$$.fragment,cp),cp.forEach(o),dp.forEach(o),gi=f(_a),Cn=s(_a,"SPAN",{});var pp=i(Cn);ui=r(pp,"Blip2Processor"),pp.forEach(o),_a.forEach(o),Xr=f(t),O=s(t,"DIV",{class:!0});var ae=i(O);w(At.$$.fragment,ae),_i=f(ae),En=s(ae,"P",{});var mp=i(En);vi=r(mp,"Constructs a BLIP-2 processor which wraps a BLIP image processor and an OPT/T5 tokenizer into a single processor."),mp.forEach(o),bi=f(ae),S=s(ae,"P",{});var K=i(S);So=s(K,"A",{href:!0});var fp=i(So);$i=r(fp,"BlipProcessor"),fp.forEach(o),wi=r(K," offers all the functionalities of "),Do=s(K,"A",{href:!0});var hp=i(Do);Bi=r(hp,"BlipImageProcessor"),hp.forEach(o),yi=r(K," and "),Qo=s(K,"A",{href:!0});var gp=i(Qo);ki=r(gp,"AutoTokenizer"),gp.forEach(o),Ti=r(K,`. See the docstring
of `),jn=s(K,"CODE",{});var up=i(jn);Pi=r(up,"__call__()"),up.forEach(o),xi=r(K," and "),Vo=s(K,"A",{href:!0});var _p=i(Vo);Ci=r(_p,"decode()"),_p.forEach(o),Ei=r(K," for more information."),K.forEach(o),ji=f(ae),Ne=s(ae,"DIV",{class:!0});var va=i(Ne);w(Ot.$$.fragment,va),qi=f(va),St=s(va,"P",{});var ba=i(St);Mi=r(ba,"This method forwards all its arguments to PreTrainedTokenizer\u2019s "),No=s(ba,"A",{href:!0});var vp=i(No);zi=r(vp,"batch_decode()"),vp.forEach(o),Ii=r(ba,`. Please
refer to the docstring of this method for more information.`),ba.forEach(o),va.forEach(o),Fi=f(ae),Ge=s(ae,"DIV",{class:!0});var $a=i(Ge);w(Dt.$$.fragment,$a),Li=f($a),Qt=s($a,"P",{});var wa=i(Qt);Ai=r(wa,"This method forwards all its arguments to PreTrainedTokenizer\u2019s "),Go=s(wa,"A",{href:!0});var bp=i(Go);Oi=r(bp,"decode()"),bp.forEach(o),Si=r(wa,`. Please refer
to the docstring of this method for more information.`),wa.forEach(o),$a.forEach(o),ae.forEach(o),Yr=f(t),ue=s(t,"H2",{class:!0});var Ba=i(ue);We=s(Ba,"A",{id:!0,class:!0,href:!0});var $p=i(We);qn=s($p,"SPAN",{});var wp=i(qn);w(Vt.$$.fragment,wp),wp.forEach(o),$p.forEach(o),Di=f(Ba),Mn=s(Ba,"SPAN",{});var Bp=i(Mn);Qi=r(Bp,"Blip2VisionModel"),Bp.forEach(o),Ba.forEach(o),Zr=f(t),_e=s(t,"DIV",{class:!0});var ya=i(_e);w(Nt.$$.fragment,ya),Vi=f(ya),te=s(ya,"DIV",{class:!0});var rn=i(te);w(Gt.$$.fragment,rn),Ni=f(rn),ve=s(rn,"P",{});var an=i(ve);Gi=r(an,"The "),Wo=s(an,"A",{href:!0});var yp=i(Wo);Wi=r(yp,"Blip2VisionModel"),yp.forEach(o),Hi=r(an," forward method, overrides the "),zn=s(an,"CODE",{});var kp=i(zn);Ri=r(kp,"__call__"),kp.forEach(o),Ui=r(an," special method."),an.forEach(o),Ji=f(rn),w(He.$$.fragment,rn),rn.forEach(o),ya.forEach(o),ea=f(t),be=s(t,"H2",{class:!0});var ka=i(be);Re=s(ka,"A",{id:!0,class:!0,href:!0});var Tp=i(Re);In=s(Tp,"SPAN",{});var Pp=i(In);w(Wt.$$.fragment,Pp),Pp.forEach(o),Tp.forEach(o),Ki=f(ka),Fn=s(ka,"SPAN",{});var xp=i(Fn);Xi=r(xp,"Blip2QFormerModel"),xp.forEach(o),ka.forEach(o),ta=f(t),J=s(t,"DIV",{class:!0});var sn=i(J);w(Ht.$$.fragment,sn),Yi=f(sn),Ln=s(sn,"P",{});var Cp=i(Ln);Zi=r(Cp,"Querying Transformer (Q-Former), used in BLIP-2."),Cp.forEach(o),el=f(sn),oe=s(sn,"DIV",{class:!0});var ln=i(oe);w(Rt.$$.fragment,ln),tl=f(ln),q=s(ln,"P",{});var F=i(q);ol=r(F,"encoder_hidden_states  ("),An=s(F,"CODE",{});var Ep=i(An);nl=r(Ep,"torch.FloatTensor"),Ep.forEach(o),rl=r(F," of shape "),On=s(F,"CODE",{});var jp=i(On);al=r(jp,"(batch_size, sequence_length, hidden_size)"),jp.forEach(o),sl=r(F,", "),Sn=s(F,"CODE",{});var qp=i(Sn);il=r(qp,"optional"),qp.forEach(o),ll=r(F,`):
Sequence of hidden-states at the output of the last layer of the encoder. Used in the cross-attention if
the model is configured as a decoder.
encoder_attention_mask (`),Dn=s(F,"CODE",{});var Mp=i(Dn);dl=r(Mp,"torch.FloatTensor"),Mp.forEach(o),cl=r(F," of shape "),Qn=s(F,"CODE",{});var zp=i(Qn);pl=r(zp,"(batch_size, sequence_length)"),zp.forEach(o),ml=r(F,", "),Vn=s(F,"CODE",{});var Ip=i(Vn);fl=r(Ip,"optional"),Ip.forEach(o),hl=r(F,`):
Mask to avoid performing attention on the padding token indices of the encoder input. This mask is used in
the cross-attention if the model is configured as a decoder. Mask values selected in `),Nn=s(F,"CODE",{});var Fp=i(Nn);gl=r(Fp,"[0, 1]"),Fp.forEach(o),ul=r(F,":"),F.forEach(o),_l=f(ln),Ut=s(ln,"UL",{});var Ta=i(Ut);Jt=s(Ta,"LI",{});var Pa=i(Jt);vl=r(Pa,"1 for tokens that are "),Gn=s(Pa,"STRONG",{});var Lp=i(Gn);bl=r(Lp,"not masked"),Lp.forEach(o),$l=r(Pa,","),Pa.forEach(o),wl=f(Ta),P=s(Ta,"LI",{});var C=i(P);Bl=r(C,"0 for tokens that are "),Wn=s(C,"STRONG",{});var Ap=i(Wn);yl=r(Ap,"masked"),Ap.forEach(o),kl=r(C,`.
past_key_values (`),Hn=s(C,"CODE",{});var Op=i(Hn);Tl=r(Op,"tuple(tuple(torch.FloatTensor))"),Op.forEach(o),Pl=r(C," of length "),Rn=s(C,"CODE",{});var Sp=i(Rn);xl=r(Sp,"config.n_layers"),Sp.forEach(o),Cl=r(C,` with each tuple having 4 tensors of:
shape `),Un=s(C,"CODE",{});var Dp=i(Un);El=r(Dp,"(batch_size, num_heads, sequence_length - 1, embed_size_per_head)"),Dp.forEach(o),jl=r(C,`): Contains precomputed key and
value hidden states of the attention blocks. Can be used to speed up decoding. If `),Jn=s(C,"CODE",{});var Qp=i(Jn);ql=r(Qp,"past_key_values"),Qp.forEach(o),Ml=r(C,` are
used, the user can optionally input only the last `),Kn=s(C,"CODE",{});var Vp=i(Kn);zl=r(Vp,"decoder_input_ids"),Vp.forEach(o),Il=r(C,` (those that don\u2019t have their past key
value states given to this model) of shape `),Xn=s(C,"CODE",{});var Np=i(Xn);Fl=r(Np,"(batch_size, 1)"),Np.forEach(o),Ll=r(C," instead of all "),Yn=s(C,"CODE",{});var Gp=i(Yn);Al=r(Gp,"decoder_input_ids"),Gp.forEach(o),Ol=r(C,` of shape
`),Zn=s(C,"CODE",{});var Wp=i(Zn);Sl=r(Wp,"(batch_size, sequence_length)"),Wp.forEach(o),Dl=r(C,`.
use_cache (`),er=s(C,"CODE",{});var Hp=i(er);Ql=r(Hp,"bool"),Hp.forEach(o),Vl=r(C,", "),tr=s(C,"CODE",{});var Rp=i(tr);Nl=r(Rp,"optional"),Rp.forEach(o),Gl=r(C,`):
If set to `),or=s(C,"CODE",{});var Up=i(or);Wl=r(Up,"True"),Up.forEach(o),Hl=r(C,", "),nr=s(C,"CODE",{});var Jp=i(nr);Rl=r(Jp,"past_key_values"),Jp.forEach(o),Ul=r(C,` key value states are returned and can be used to speed up decoding (see
`),rr=s(C,"CODE",{});var Kp=i(rr);Jl=r(Kp,"past_key_values"),Kp.forEach(o),Kl=r(C,")."),C.forEach(o),Ta.forEach(o),ln.forEach(o),sn.forEach(o),oa=f(t),$e=s(t,"H2",{class:!0});var xa=i($e);Ue=s(xa,"A",{id:!0,class:!0,href:!0});var Xp=i(Ue);ar=s(Xp,"SPAN",{});var Yp=i(ar);w(Kt.$$.fragment,Yp),Yp.forEach(o),Xp.forEach(o),Xl=f(xa),sr=s(xa,"SPAN",{});var Zp=i(sr);Yl=r(Zp,"Blip2Model"),Zp.forEach(o),xa.forEach(o),na=f(t),j=s(t,"DIV",{class:!0});var L=i(j);w(Xt.$$.fragment,L),Zl=f(L),ir=s(L,"P",{});var em=i(ir);ed=r(em,`BLIP-2 Model for generating text and image features. The model consists of a vision encoder, Querying Transformer
(Q-Former) and a language model.`),em.forEach(o),td=f(L),Yt=s(L,"P",{});var Ca=i(Yt);od=r(Ca,"This model inherits from "),Ho=s(Ca,"A",{href:!0});var tm=i(Ho);nd=r(tm,"PreTrainedModel"),tm.forEach(o),rd=r(Ca,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Ca.forEach(o),ad=f(L),Zt=s(L,"P",{});var Ea=i(Zt);sd=r(Ea,"This model is also a PyTorch "),eo=s(Ea,"A",{href:!0,rel:!0});var om=i(eo);id=r(om,"torch.nn.Module"),om.forEach(o),ld=r(Ea,` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),Ea.forEach(o),dd=f(L),G=s(L,"DIV",{class:!0});var ct=i(G);w(to.$$.fragment,ct),cd=f(ct),we=s(ct,"P",{});var dn=i(we);pd=r(dn,"The "),Ro=s(dn,"A",{href:!0});var nm=i(Ro);md=r(nm,"Blip2Model"),nm.forEach(o),fd=r(dn," forward method, overrides the "),lr=s(dn,"CODE",{});var rm=i(lr);hd=r(rm,"__call__"),rm.forEach(o),gd=r(dn," special method."),dn.forEach(o),ud=f(ct),w(Je.$$.fragment,ct),_d=f(ct),w(Ke.$$.fragment,ct),ct.forEach(o),vd=f(L),W=s(L,"DIV",{class:!0});var pt=i(W);w(oo.$$.fragment,pt),bd=f(pt),Be=s(pt,"P",{});var cn=i(Be);$d=r(cn,"The "),Uo=s(cn,"A",{href:!0});var am=i(Uo);wd=r(am,"Blip2Model"),am.forEach(o),Bd=r(cn," forward method, overrides the "),dr=s(cn,"CODE",{});var sm=i(dr);yd=r(sm,"__call__"),sm.forEach(o),kd=r(cn," special method."),cn.forEach(o),Td=f(pt),w(Xe.$$.fragment,pt),Pd=f(pt),w(Ye.$$.fragment,pt),pt.forEach(o),xd=f(L),H=s(L,"DIV",{class:!0});var mt=i(H);w(no.$$.fragment,mt),Cd=f(mt),ye=s(mt,"P",{});var pn=i(ye);Ed=r(pn,"The "),Jo=s(pn,"A",{href:!0});var im=i(Jo);jd=r(im,"Blip2Model"),im.forEach(o),qd=r(pn," forward method, overrides the "),cr=s(pn,"CODE",{});var lm=i(cr);Md=r(lm,"__call__"),lm.forEach(o),zd=r(pn," special method."),pn.forEach(o),Id=f(mt),w(Ze.$$.fragment,mt),Fd=f(mt),w(et.$$.fragment,mt),mt.forEach(o),Ld=f(L),R=s(L,"DIV",{class:!0});var ft=i(R);w(ro.$$.fragment,ft),Ad=f(ft),ke=s(ft,"P",{});var mn=i(ke);Od=r(mn,"The "),Ko=s(mn,"A",{href:!0});var dm=i(Ko);Sd=r(dm,"Blip2Model"),dm.forEach(o),Dd=r(mn," forward method, overrides the "),pr=s(mn,"CODE",{});var cm=i(pr);Qd=r(cm,"__call__"),cm.forEach(o),Vd=r(mn," special method."),mn.forEach(o),Nd=f(ft),w(tt.$$.fragment,ft),Gd=f(ft),w(ot.$$.fragment,ft),ft.forEach(o),L.forEach(o),ra=f(t),Te=s(t,"H2",{class:!0});var ja=i(Te);nt=s(ja,"A",{id:!0,class:!0,href:!0});var pm=i(nt);mr=s(pm,"SPAN",{});var mm=i(mr);w(ao.$$.fragment,mm),mm.forEach(o),pm.forEach(o),Wd=f(ja),fr=s(ja,"SPAN",{});var fm=i(fr);Hd=r(fm,"Blip2ForConditionalGeneration"),fm.forEach(o),ja.forEach(o),aa=f(t),M=s(t,"DIV",{class:!0});var D=i(M);w(so.$$.fragment,D),Rd=f(D),hr=s(D,"P",{});var hm=i(hr);Ud=r(hm,`BLIP-2 Model for generating text given an image and an optional text prompt. The model consists of a vision
encoder, Querying Transformer (Q-Former) and a language model.`),hm.forEach(o),Jd=f(D),io=s(D,"P",{});var qa=i(io);Kd=r(qa,"One can optionally pass "),gr=s(qa,"CODE",{});var gm=i(gr);Xd=r(gm,"input_ids"),gm.forEach(o),Yd=r(qa,` to the model, which serve as a text prompt, to make the language model continue
the prompt. Otherwise, the language model starts generating text from the [BOS] (beginning-of-sequence) token.`),qa.forEach(o),Zd=f(D),lo=s(D,"P",{});var Ma=i(lo);ec=r(Ma,"This model inherits from "),Xo=s(Ma,"A",{href:!0});var um=i(Xo);tc=r(um,"PreTrainedModel"),um.forEach(o),oc=r(Ma,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Ma.forEach(o),nc=f(D),co=s(D,"P",{});var za=i(co);rc=r(za,"This model is also a PyTorch "),po=s(za,"A",{href:!0,rel:!0});var _m=i(po);ac=r(_m,"torch.nn.Module"),_m.forEach(o),sc=r(za,` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),za.forEach(o),ic=f(D),I=s(D,"DIV",{class:!0});var U=i(I);w(mo.$$.fragment,U),lc=f(U),Pe=s(U,"P",{});var fn=i(Pe);dc=r(fn,"The "),Yo=s(fn,"A",{href:!0});var vm=i(Yo);cc=r(vm,"Blip2ForConditionalGeneration"),vm.forEach(o),pc=r(fn," forward method, overrides the "),ur=s(fn,"CODE",{});var bm=i(ur);mc=r(bm,"__call__"),bm.forEach(o),fc=r(fn," special method."),fn.forEach(o),hc=f(U),w(rt.$$.fragment,U),gc=f(U),_r=s(U,"P",{});var $m=i(_r);uc=r($m,"Examples:"),$m.forEach(o),_c=f(U),w(at.$$.fragment,U),vc=f(U),w(st.$$.fragment,U),U.forEach(o),bc=f(D),it=s(D,"DIV",{class:!0});var Ia=i(it);w(fo.$$.fragment,Ia),$c=f(Ia),ho=s(Ia,"P",{});var Fa=i(ho);wc=r(Fa,"Overrides "),vr=s(Fa,"CODE",{});var wm=i(vr);Bc=r(wm,"generate"),wm.forEach(o),yc=r(Fa," function to be able to use the model as a conditional generator."),Fa.forEach(o),Ia.forEach(o),D.forEach(o),this.h()},h(){c(d,"name","hf:doc:metadata"),c(d,"content",JSON.stringify(Gm)),c(h,"id","blip2"),c(h,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(h,"href","#blip2"),c(u,"class","relative group"),c(qe,"id","overview"),c(qe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(qe,"href","#overview"),c(se,"class","relative group"),c(gt,"href","https://arxiv.org/abs/2301.12597"),c(gt,"rel","nofollow"),c(ut,"href","https://arxiv.org/abs/2204.14198"),c(ut,"rel","nofollow"),c(wo,"href","/docs/transformers/main/en/model_doc/blip-2#transformers.Blip2Processor"),Pm(ze.src,Tc="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/transformers/model_doc/blip2_architecture.jpg")||c(ze,"src",Tc),c(ze,"alt","drawing"),c(ze,"width","600"),c(Bo,"href","https://arxiv.org/abs/2301.12597"),c($t,"href","https://huggingface.co/nielsr"),c($t,"rel","nofollow"),c(wt,"href","https://github.com/salesforce/LAVIS/tree/5ee63d688ba4cebff63acee04adaef2dee9af207"),c(wt,"rel","nofollow"),c(Ie,"id","resources"),c(Ie,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Ie,"href","#resources"),c(ie,"class","relative group"),c(kt,"href","https://github.com/NielsRogge/Transformers-Tutorials/tree/master/BLIP-2"),c(kt,"rel","nofollow"),c(Fe,"id","transformers.Blip2Config"),c(Fe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Fe,"href","#transformers.Blip2Config"),c(le,"class","relative group"),c(Po,"href","/docs/transformers/main/en/model_doc/blip-2#transformers.Blip2Config"),c(xo,"href","/docs/transformers/main/en/model_doc/blip-2#transformers.Blip2ForConditionalGeneration"),c(xt,"href","https://huggingface.co/Salesforce/blip2-opt-2.7b"),c(xt,"rel","nofollow"),c(Co,"href","/docs/transformers/main/en/main_classes/configuration#transformers.PretrainedConfig"),c(Eo,"href","/docs/transformers/main/en/main_classes/configuration#transformers.PretrainedConfig"),c(jo,"href","/docs/transformers/main/en/model_doc/blip-2#transformers.Blip2Config"),c(Ae,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(A,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Oe,"id","transformers.Blip2VisionConfig"),c(Oe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Oe,"href","#transformers.Blip2VisionConfig"),c(ce,"class","relative group"),c(qo,"href","/docs/transformers/main/en/model_doc/blip-2#transformers.Blip2VisionModel"),c(Mt,"href","https://huggingface.co/Salesforce/blip2-opt-2.7b"),c(Mt,"rel","nofollow"),c(Mo,"href","/docs/transformers/main/en/main_classes/configuration#transformers.PretrainedConfig"),c(zo,"href","/docs/transformers/main/en/main_classes/configuration#transformers.PretrainedConfig"),c(Q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(De,"id","transformers.Blip2QFormerConfig"),c(De,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(De,"href","#transformers.Blip2QFormerConfig"),c(fe,"class","relative group"),c(Io,"href","/docs/transformers/main/en/model_doc/blip-2#transformers.Blip2QFormerModel"),c(Ft,"href","https://huggingface.co/Salesforce/blip2-opt-2.7b"),c(Ft,"rel","nofollow"),c(Fo,"href","/docs/transformers/main/en/main_classes/configuration#transformers.PretrainedConfig"),c(Lo,"href","/docs/transformers/main/en/main_classes/configuration#transformers.PretrainedConfig"),c(Ao,"href","/docs/transformers/main/en/model_doc/blip-2#transformers.Blip2QFormerModel"),c(Oo,"href","/docs/transformers/main/en/model_doc/bert#transformers.BertLMHeadModel"),c(V,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Ve,"id","transformers.Blip2Processor"),c(Ve,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Ve,"href","#transformers.Blip2Processor"),c(ge,"class","relative group"),c(So,"href","/docs/transformers/main/en/model_doc/blip#transformers.BlipProcessor"),c(Do,"href","/docs/transformers/main/en/model_doc/blip#transformers.BlipImageProcessor"),c(Qo,"href","/docs/transformers/main/en/model_doc/auto#transformers.AutoTokenizer"),c(Vo,"href","/docs/transformers/main/en/model_doc/blip#transformers.BlipProcessor.decode"),c(No,"href","/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.batch_decode"),c(Ne,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Go,"href","/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.decode"),c(Ge,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(O,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(We,"id","transformers.Blip2VisionModel"),c(We,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(We,"href","#transformers.Blip2VisionModel"),c(ue,"class","relative group"),c(Wo,"href","/docs/transformers/main/en/model_doc/blip-2#transformers.Blip2VisionModel"),c(te,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(_e,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Re,"id","transformers.Blip2QFormerModel"),c(Re,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Re,"href","#transformers.Blip2QFormerModel"),c(be,"class","relative group"),c(oe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(J,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Ue,"id","transformers.Blip2Model"),c(Ue,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Ue,"href","#transformers.Blip2Model"),c($e,"class","relative group"),c(Ho,"href","/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel"),c(eo,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),c(eo,"rel","nofollow"),c(Ro,"href","/docs/transformers/main/en/model_doc/blip-2#transformers.Blip2Model"),c(G,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Uo,"href","/docs/transformers/main/en/model_doc/blip-2#transformers.Blip2Model"),c(W,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Jo,"href","/docs/transformers/main/en/model_doc/blip-2#transformers.Blip2Model"),c(H,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Ko,"href","/docs/transformers/main/en/model_doc/blip-2#transformers.Blip2Model"),c(R,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(j,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(nt,"id","transformers.Blip2ForConditionalGeneration"),c(nt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(nt,"href","#transformers.Blip2ForConditionalGeneration"),c(Te,"class","relative group"),c(Xo,"href","/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel"),c(po,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),c(po,"rel","nofollow"),c(Yo,"href","/docs/transformers/main/en/model_doc/blip-2#transformers.Blip2ForConditionalGeneration"),c(I,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(it,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(M,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(t,g){e(document.head,d),_(t,b,g),_(t,u,g),e(u,h),e(h,v),B(l,v,null),e(u,p),e(u,E),e(E,La),_(t,qr,g),_(t,se,g),e(se,qe),e(qe,gn),B(ht,gn,null),e(se,Aa),e(se,un),e(un,Oa),_(t,Mr,g),_(t,Y,g),e(Y,Sa),e(Y,gt),e(gt,Da),e(Y,Qa),e(Y,ut),e(ut,Va),e(Y,Na),_(t,zr,g),_(t,vo,g),e(vo,Ga),_(t,Ir,g),_(t,bo,g),e(bo,_n),e(_n,Wa),_(t,Fr,g),_(t,$o,g),e($o,Ha),_(t,Lr,g),_(t,Me,g),e(Me,_t),e(_t,Ra),e(_t,vn),e(vn,Ua),e(_t,Ja),e(Me,Ka),e(Me,vt),e(vt,Xa),e(vt,wo),e(wo,Ya),e(vt,Za),_(t,Ar,g),_(t,ze,g),_(t,Or,g),_(t,bt,g),e(bt,es),e(bt,Bo),e(Bo,ts),_(t,Sr,g),_(t,Z,g),e(Z,os),e(Z,$t),e($t,ns),e(Z,rs),e(Z,wt),e(wt,as),e(Z,ss),_(t,Dr,g),_(t,ie,g),e(ie,Ie),e(Ie,bn),B(Bt,bn,null),e(ie,is),e(ie,$n),e($n,ls),_(t,Qr,g),_(t,yo,g),e(yo,ds),_(t,Vr,g),_(t,ko,g),e(ko,yt),e(yt,cs),e(yt,kt),e(kt,ps),e(yt,ms),_(t,Nr,g),_(t,To,g),e(To,fs),_(t,Gr,g),_(t,le,g),e(le,Fe),e(Fe,wn),B(Tt,wn,null),e(le,hs),e(le,Bn),e(Bn,gs),_(t,Wr,g),_(t,A,g),B(Pt,A,null),e(A,us),e(A,ee),e(ee,Po),e(Po,_s),e(ee,vs),e(ee,xo),e(xo,bs),e(ee,$s),e(ee,xt),e(xt,ws),e(ee,Bs),e(A,ys),e(A,de),e(de,ks),e(de,Co),e(Co,Ts),e(de,Ps),e(de,Eo),e(Eo,xs),e(de,Cs),e(A,Es),B(Le,A,null),e(A,js),e(A,Ae),B(Ct,Ae,null),e(Ae,qs),e(Ae,Et),e(Et,Ms),e(Et,jo),e(jo,zs),e(Et,Is),_(t,Hr,g),_(t,ce,g),e(ce,Oe),e(Oe,yn),B(jt,yn,null),e(ce,Fs),e(ce,kn),e(kn,Ls),_(t,Rr,g),_(t,Q,g),B(qt,Q,null),e(Q,As),e(Q,pe),e(pe,Os),e(pe,qo),e(qo,Ss),e(pe,Ds),e(pe,Mt),e(Mt,Qs),e(pe,Vs),e(Q,Ns),e(Q,me),e(me,Gs),e(me,Mo),e(Mo,Ws),e(me,Hs),e(me,zo),e(zo,Rs),e(me,Us),e(Q,Js),B(Se,Q,null),_(t,Ur,g),_(t,fe,g),e(fe,De),e(De,Tn),B(zt,Tn,null),e(fe,Ks),e(fe,Pn),e(Pn,Xs),_(t,Jr,g),_(t,V,g),B(It,V,null),e(V,Ys),e(V,N),e(N,Zs),e(N,Io),e(Io,ei),e(N,ti),e(N,Ft),e(Ft,oi),e(N,ni),e(N,Fo),e(Fo,ri),e(N,ai),e(N,Lo),e(Lo,si),e(N,ii),e(V,li),e(V,he),e(he,di),e(he,Ao),e(Ao,ci),e(he,pi),e(he,Oo),e(Oo,mi),e(he,fi),e(V,hi),B(Qe,V,null),_(t,Kr,g),_(t,ge,g),e(ge,Ve),e(Ve,xn),B(Lt,xn,null),e(ge,gi),e(ge,Cn),e(Cn,ui),_(t,Xr,g),_(t,O,g),B(At,O,null),e(O,_i),e(O,En),e(En,vi),e(O,bi),e(O,S),e(S,So),e(So,$i),e(S,wi),e(S,Do),e(Do,Bi),e(S,yi),e(S,Qo),e(Qo,ki),e(S,Ti),e(S,jn),e(jn,Pi),e(S,xi),e(S,Vo),e(Vo,Ci),e(S,Ei),e(O,ji),e(O,Ne),B(Ot,Ne,null),e(Ne,qi),e(Ne,St),e(St,Mi),e(St,No),e(No,zi),e(St,Ii),e(O,Fi),e(O,Ge),B(Dt,Ge,null),e(Ge,Li),e(Ge,Qt),e(Qt,Ai),e(Qt,Go),e(Go,Oi),e(Qt,Si),_(t,Yr,g),_(t,ue,g),e(ue,We),e(We,qn),B(Vt,qn,null),e(ue,Di),e(ue,Mn),e(Mn,Qi),_(t,Zr,g),_(t,_e,g),B(Nt,_e,null),e(_e,Vi),e(_e,te),B(Gt,te,null),e(te,Ni),e(te,ve),e(ve,Gi),e(ve,Wo),e(Wo,Wi),e(ve,Hi),e(ve,zn),e(zn,Ri),e(ve,Ui),e(te,Ji),B(He,te,null),_(t,ea,g),_(t,be,g),e(be,Re),e(Re,In),B(Wt,In,null),e(be,Ki),e(be,Fn),e(Fn,Xi),_(t,ta,g),_(t,J,g),B(Ht,J,null),e(J,Yi),e(J,Ln),e(Ln,Zi),e(J,el),e(J,oe),B(Rt,oe,null),e(oe,tl),e(oe,q),e(q,ol),e(q,An),e(An,nl),e(q,rl),e(q,On),e(On,al),e(q,sl),e(q,Sn),e(Sn,il),e(q,ll),e(q,Dn),e(Dn,dl),e(q,cl),e(q,Qn),e(Qn,pl),e(q,ml),e(q,Vn),e(Vn,fl),e(q,hl),e(q,Nn),e(Nn,gl),e(q,ul),e(oe,_l),e(oe,Ut),e(Ut,Jt),e(Jt,vl),e(Jt,Gn),e(Gn,bl),e(Jt,$l),e(Ut,wl),e(Ut,P),e(P,Bl),e(P,Wn),e(Wn,yl),e(P,kl),e(P,Hn),e(Hn,Tl),e(P,Pl),e(P,Rn),e(Rn,xl),e(P,Cl),e(P,Un),e(Un,El),e(P,jl),e(P,Jn),e(Jn,ql),e(P,Ml),e(P,Kn),e(Kn,zl),e(P,Il),e(P,Xn),e(Xn,Fl),e(P,Ll),e(P,Yn),e(Yn,Al),e(P,Ol),e(P,Zn),e(Zn,Sl),e(P,Dl),e(P,er),e(er,Ql),e(P,Vl),e(P,tr),e(tr,Nl),e(P,Gl),e(P,or),e(or,Wl),e(P,Hl),e(P,nr),e(nr,Rl),e(P,Ul),e(P,rr),e(rr,Jl),e(P,Kl),_(t,oa,g),_(t,$e,g),e($e,Ue),e(Ue,ar),B(Kt,ar,null),e($e,Xl),e($e,sr),e(sr,Yl),_(t,na,g),_(t,j,g),B(Xt,j,null),e(j,Zl),e(j,ir),e(ir,ed),e(j,td),e(j,Yt),e(Yt,od),e(Yt,Ho),e(Ho,nd),e(Yt,rd),e(j,ad),e(j,Zt),e(Zt,sd),e(Zt,eo),e(eo,id),e(Zt,ld),e(j,dd),e(j,G),B(to,G,null),e(G,cd),e(G,we),e(we,pd),e(we,Ro),e(Ro,md),e(we,fd),e(we,lr),e(lr,hd),e(we,gd),e(G,ud),B(Je,G,null),e(G,_d),B(Ke,G,null),e(j,vd),e(j,W),B(oo,W,null),e(W,bd),e(W,Be),e(Be,$d),e(Be,Uo),e(Uo,wd),e(Be,Bd),e(Be,dr),e(dr,yd),e(Be,kd),e(W,Td),B(Xe,W,null),e(W,Pd),B(Ye,W,null),e(j,xd),e(j,H),B(no,H,null),e(H,Cd),e(H,ye),e(ye,Ed),e(ye,Jo),e(Jo,jd),e(ye,qd),e(ye,cr),e(cr,Md),e(ye,zd),e(H,Id),B(Ze,H,null),e(H,Fd),B(et,H,null),e(j,Ld),e(j,R),B(ro,R,null),e(R,Ad),e(R,ke),e(ke,Od),e(ke,Ko),e(Ko,Sd),e(ke,Dd),e(ke,pr),e(pr,Qd),e(ke,Vd),e(R,Nd),B(tt,R,null),e(R,Gd),B(ot,R,null),_(t,ra,g),_(t,Te,g),e(Te,nt),e(nt,mr),B(ao,mr,null),e(Te,Wd),e(Te,fr),e(fr,Hd),_(t,aa,g),_(t,M,g),B(so,M,null),e(M,Rd),e(M,hr),e(hr,Ud),e(M,Jd),e(M,io),e(io,Kd),e(io,gr),e(gr,Xd),e(io,Yd),e(M,Zd),e(M,lo),e(lo,ec),e(lo,Xo),e(Xo,tc),e(lo,oc),e(M,nc),e(M,co),e(co,rc),e(co,po),e(po,ac),e(co,sc),e(M,ic),e(M,I),B(mo,I,null),e(I,lc),e(I,Pe),e(Pe,dc),e(Pe,Yo),e(Yo,cc),e(Pe,pc),e(Pe,ur),e(ur,mc),e(Pe,fc),e(I,hc),B(rt,I,null),e(I,gc),e(I,_r),e(_r,uc),e(I,_c),B(at,I,null),e(I,vc),B(st,I,null),e(M,bc),e(M,it),B(fo,it,null),e(it,$c),e(it,ho),e(ho,wc),e(ho,vr),e(vr,Bc),e(ho,yc),sa=!0},p(t,[g]){const go={};g&2&&(go.$$scope={dirty:g,ctx:t}),Le.$set(go);const br={};g&2&&(br.$$scope={dirty:g,ctx:t}),Se.$set(br);const $r={};g&2&&($r.$$scope={dirty:g,ctx:t}),Qe.$set($r);const wr={};g&2&&(wr.$$scope={dirty:g,ctx:t}),He.$set(wr);const uo={};g&2&&(uo.$$scope={dirty:g,ctx:t}),Je.$set(uo);const Br={};g&2&&(Br.$$scope={dirty:g,ctx:t}),Ke.$set(Br);const yr={};g&2&&(yr.$$scope={dirty:g,ctx:t}),Xe.$set(yr);const kr={};g&2&&(kr.$$scope={dirty:g,ctx:t}),Ye.$set(kr);const xe={};g&2&&(xe.$$scope={dirty:g,ctx:t}),Ze.$set(xe);const Tr={};g&2&&(Tr.$$scope={dirty:g,ctx:t}),et.$set(Tr);const Pr={};g&2&&(Pr.$$scope={dirty:g,ctx:t}),tt.$set(Pr);const xr={};g&2&&(xr.$$scope={dirty:g,ctx:t}),ot.$set(xr);const Cr={};g&2&&(Cr.$$scope={dirty:g,ctx:t}),rt.$set(Cr);const Er={};g&2&&(Er.$$scope={dirty:g,ctx:t}),at.$set(Er);const jr={};g&2&&(jr.$$scope={dirty:g,ctx:t}),st.$set(jr)},i(t){sa||(y(l.$$.fragment,t),y(ht.$$.fragment,t),y(Bt.$$.fragment,t),y(Tt.$$.fragment,t),y(Pt.$$.fragment,t),y(Le.$$.fragment,t),y(Ct.$$.fragment,t),y(jt.$$.fragment,t),y(qt.$$.fragment,t),y(Se.$$.fragment,t),y(zt.$$.fragment,t),y(It.$$.fragment,t),y(Qe.$$.fragment,t),y(Lt.$$.fragment,t),y(At.$$.fragment,t),y(Ot.$$.fragment,t),y(Dt.$$.fragment,t),y(Vt.$$.fragment,t),y(Nt.$$.fragment,t),y(Gt.$$.fragment,t),y(He.$$.fragment,t),y(Wt.$$.fragment,t),y(Ht.$$.fragment,t),y(Rt.$$.fragment,t),y(Kt.$$.fragment,t),y(Xt.$$.fragment,t),y(to.$$.fragment,t),y(Je.$$.fragment,t),y(Ke.$$.fragment,t),y(oo.$$.fragment,t),y(Xe.$$.fragment,t),y(Ye.$$.fragment,t),y(no.$$.fragment,t),y(Ze.$$.fragment,t),y(et.$$.fragment,t),y(ro.$$.fragment,t),y(tt.$$.fragment,t),y(ot.$$.fragment,t),y(ao.$$.fragment,t),y(so.$$.fragment,t),y(mo.$$.fragment,t),y(rt.$$.fragment,t),y(at.$$.fragment,t),y(st.$$.fragment,t),y(fo.$$.fragment,t),sa=!0)},o(t){k(l.$$.fragment,t),k(ht.$$.fragment,t),k(Bt.$$.fragment,t),k(Tt.$$.fragment,t),k(Pt.$$.fragment,t),k(Le.$$.fragment,t),k(Ct.$$.fragment,t),k(jt.$$.fragment,t),k(qt.$$.fragment,t),k(Se.$$.fragment,t),k(zt.$$.fragment,t),k(It.$$.fragment,t),k(Qe.$$.fragment,t),k(Lt.$$.fragment,t),k(At.$$.fragment,t),k(Ot.$$.fragment,t),k(Dt.$$.fragment,t),k(Vt.$$.fragment,t),k(Nt.$$.fragment,t),k(Gt.$$.fragment,t),k(He.$$.fragment,t),k(Wt.$$.fragment,t),k(Ht.$$.fragment,t),k(Rt.$$.fragment,t),k(Kt.$$.fragment,t),k(Xt.$$.fragment,t),k(to.$$.fragment,t),k(Je.$$.fragment,t),k(Ke.$$.fragment,t),k(oo.$$.fragment,t),k(Xe.$$.fragment,t),k(Ye.$$.fragment,t),k(no.$$.fragment,t),k(Ze.$$.fragment,t),k(et.$$.fragment,t),k(ro.$$.fragment,t),k(tt.$$.fragment,t),k(ot.$$.fragment,t),k(ao.$$.fragment,t),k(so.$$.fragment,t),k(mo.$$.fragment,t),k(rt.$$.fragment,t),k(at.$$.fragment,t),k(st.$$.fragment,t),k(fo.$$.fragment,t),sa=!1},d(t){o(d),t&&o(b),t&&o(u),T(l),t&&o(qr),t&&o(se),T(ht),t&&o(Mr),t&&o(Y),t&&o(zr),t&&o(vo),t&&o(Ir),t&&o(bo),t&&o(Fr),t&&o($o),t&&o(Lr),t&&o(Me),t&&o(Ar),t&&o(ze),t&&o(Or),t&&o(bt),t&&o(Sr),t&&o(Z),t&&o(Dr),t&&o(ie),T(Bt),t&&o(Qr),t&&o(yo),t&&o(Vr),t&&o(ko),t&&o(Nr),t&&o(To),t&&o(Gr),t&&o(le),T(Tt),t&&o(Wr),t&&o(A),T(Pt),T(Le),T(Ct),t&&o(Hr),t&&o(ce),T(jt),t&&o(Rr),t&&o(Q),T(qt),T(Se),t&&o(Ur),t&&o(fe),T(zt),t&&o(Jr),t&&o(V),T(It),T(Qe),t&&o(Kr),t&&o(ge),T(Lt),t&&o(Xr),t&&o(O),T(At),T(Ot),T(Dt),t&&o(Yr),t&&o(ue),T(Vt),t&&o(Zr),t&&o(_e),T(Nt),T(Gt),T(He),t&&o(ea),t&&o(be),T(Wt),t&&o(ta),t&&o(J),T(Ht),T(Rt),t&&o(oa),t&&o($e),T(Kt),t&&o(na),t&&o(j),T(Xt),T(to),T(Je),T(Ke),T(oo),T(Xe),T(Ye),T(no),T(Ze),T(et),T(ro),T(tt),T(ot),t&&o(ra),t&&o(Te),T(ao),t&&o(aa),t&&o(M),T(so),T(mo),T(rt),T(at),T(st),T(fo)}}}const Gm={local:"blip2",sections:[{local:"overview",title:"Overview"},{local:"resources",title:"Resources"},{local:"transformers.Blip2Config",title:"Blip2Config"},{local:"transformers.Blip2VisionConfig",title:"Blip2VisionConfig"},{local:"transformers.Blip2QFormerConfig",title:"Blip2QFormerConfig"},{local:"transformers.Blip2Processor",title:"Blip2Processor"},{local:"transformers.Blip2VisionModel",title:"Blip2VisionModel"},{local:"transformers.Blip2QFormerModel",title:"Blip2QFormerModel"},{local:"transformers.Blip2Model",title:"Blip2Model"},{local:"transformers.Blip2ForConditionalGeneration",title:"Blip2ForConditionalGeneration"}],title:"BLIP-2"};function Wm(x){return xm(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ym extends Bm{constructor(d){super();ym(this,d,Wm,Nm,km,{})}}export{Ym as default,Gm as metadata};
